/*
 *							Paragraph Sort
 *						Written by SHIMA, 1994-96
 */

#define		VERSION				"1.03"

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<fcntl.h>

#ifdef		MSDOS
#include	<io.h>
#include	<dir.h>
#include	<dos.h>
#endif

#if	defined(__TURBOC__) || defined(__MSC__)
#include	<alloc.h>
#include	<jctype.h>
#include	<jstring.h>
#include	<conio.h>
#include	<mem.h>
#endif

#ifndef	__STDC__
#define	__STDC__	1
#endif

#include	"regex.h"
#include	"psort.h"

/*************************************************************************/
/*						Some changeable Constants 						 */

#define		MAX_KEY		16			/* maximal # keys for sort			 */
#define		MAX_HEAD	16			/* maximal # Heads					 */
#define		MAX_PARA	5			/* maximal # RE to define paragraph	 */
#define		G_NEST		2			/* maximal # of nesting level of -g	 */

#ifdef	MSDOS
 SIZE 		buffer_size;			/* size of buffer for a text 		 */
 uint		max_line    =	16000;	/* maximal lines for a unit 		 */
#else
 SIZE 		buffer_size = 0x100000;	/* size of buffer for a text 		 */
 uint		max_line    =	20000;	/* maximal lines for a unit 		 */
#define		LINE_SIZE	9			/* 3/(LINE_SIZE*2) of buffer is used */
			/* max_line = buffer_size/(LINE_SIZE*sizeof(uchar *))		 */
			/*			= 29127		if  buffer_size = 1M byte			 */
#endif

#ifdef	UNIXPATH
#define		CFG_FILE	"/.psortrc"		/* path following HOME */
#define		CFG_FILE2	"/usr/local/lib/psort/psortrc"
uchar		*data_path	=			/* default path of psort.doc etc. 	 */
				"~/.psort:~/psort:/usr/local/lib/psort";
#else
#define		CFG_FILE	"psort.rc"
uchar		*data_path = ".;~";
#endif
										/* format for -H<key>/<key>...	 */
#define		MULT_HEAD	"\n\x22%s\x22,\t\x22%s\x22\n"
#define		SINGLE_HEAD	"\n\x22%s\x22\n"

#ifdef	MSDOS
#define		SUB_size	0x8000L
#define		MIN_size	0x10000L
#define		MAX_PATH	80
#else
#define		MIN_size	0x10000
#define		MIN_BUF		0x40000
#define		MAX_PATH	256
#endif

/*************************************************************************/
/*					Define some functions and macros					 */

#ifdef	MSDOS
#define	INT32			long
#define	Calloc(x,y)	farcalloc(x,y)
#define	INT_OUT			"%ld"
#else
#define	INT32			int
#define	Calloc(x,y)	calloc(x,y)
#define	INT_OUT			"%d"
#endif

#ifdef	__TURBOC__
#define	stci_d(x,y)	itoa(y,x,10)
extern unsigned _stklen=0x8000;
#else
#define	stci_d(x,y)	sprintf(x,"%d",y)
#endif

#ifdef	NO_MEMMOVE
void memmove(char *d, char *s, int l)
{
	if((HUGEBUF*)d < (HUGEBUF*)s){
		while(l--) *d++ = *s++;
	}else if(d != s){
		d += l;
		s += l;
		while(l--) *--d = *--s;
	}
}
#endif

#ifdef	NO_MEMCMP
int MemCmp(uchar *s, uchar *t, int len)
{
	int diff;

	while(len-- > 0)
		if (diff = (int)(*s++) - (int)(*t++)) return diff;
	return 0;
}
#else
#define	MemCmp(s,t,l)	memcmp(s,t,l)
#endif

#ifdef	KANJI
 #ifdef	EUC
   #ifdef JIS
     #define	K_TYPE		"EUC/JIS/ShiftJIS"
   #else
     #define	K_TYPE		"EUC"
   #endif
 #else
   #ifdef JIS
     #define	K_TYPE		"ShiftJIS/JIS/EUC"
   #else
     #define	K_TYPE		"SJIS"
   #endif
 #endif
 #ifndef	__JSTRING_H
   #ifdef EUC
   #define UC(c)        ((unsigned char)(c))
   #define iskanji(c)   ((c) & 0x80)
   #else /* sjis */
   #define UC(c)        ((unsigned char)(c))
   #define BD(l, h, c)  (((l) <= (c))&&((c) <= (h)))
   #define iskanji(c)   (BD(0x81, 0x9F, UC(c)) || BD(0xE0, 0xFC, UC(c)))
   #endif
 #endif

/* #define	StrStr(x,y)		jstrstr(x,y)
 */
#define	StrChr(x,y)		jstrchr(x,y)
#define	StrSkip(x,y)	jstrskip(x,y)
#define	StrPbrk(x,y)	jstrmatch(x,y)
 #ifndef	__JSTRING_H

/* Find the first place where  ch  appears.
   We assume that  ch  is a 1 byte character. */
 uchar *jstrchr(uchar *s, uchar ch)
{
	uchar *t, *u;

	for(t=s; *t; t++){
		if(iskanji(*t)){
			if(!*++t)
				t--;
			continue;
		}
		if(*t==ch)
			return t;
	}
	return	NULL;
}

/* Skip characters appeared in the string  t. */
 uchar *jstrskip(uchar *s, uchar *t)
{
	char *ps, *pt;

 	for(ps=s; *ps; ps++){
		for(pt=t;;pt++){
			if(!*pt)
				return ps;
			if(*pt == *ps){
				if(!iskanji(*ps))
					break;
				if(*++pt == ps[1] && ps[1]){
					ps++;
					break;
				}
			}
		}
	}
	return ps;
}

/* Find the first place where a character in the 
   string  t  appeares. */
uchar	*jstrmatch(uchar *s, uchar *t)
{
	char *ps, *pt;

	for(ps=s; *ps; ps++){
		for(pt=t;*pt;pt++){
			if(*pt==*ps && (!iskanji(*ps) || *++pt == ps[1]))
				return ps;
		}
		if(iskanji(*ps) && ps[1])
			ps++;
	}
	return NULL;
}

 #endif
#else

#define	K_TYPE			"English"

/* #define	StrStr(x,y)		strstr(x,y)
 */
#define	StrChr(x,y)		strchr(x,y)
#define	StrPbrk(x,y)	strpbrk(x,y)
#define	StrSkip(x,y)	strskip(x,y)

uchar *strskip(uchar *s, uchar *t)
{
	char *ps, *pt;

	for(ps=s; *ps; ps++){
		for(pt=t;;){
			if(!*pt)		return ps;
			if(*pt++==*ps)	break;
		}
	}
	return ps;
}
#endif

/*************************************************************************/
/*						Define some variables							 */

#define	MAXDIV		5
#define	MAX_TYPE	8
#define	USIZE		256

#ifdef	KANJI
#ifdef	EUC
#define	MAX_RCODE	0x3000
#else
#define	MAX_RCODE	0x3d00
#endif
#endif

BUFFER	*tex0;								/* top of a buffer 				*/
BUFFER	*text;								/* pointer for current buffer	*/
BUFFER	*tex[MAXDIV];						/* top of divided buffer		*/

uchar	**lptr;								/* top of blocks to compare		*/
uchar	**work;								/* work for merge sort			*/
uchar	reg_buf[REG_size];					/* string for <re_exp> 			*/
uchar	org_path[MAX_ARG0];					/* original path name			*/
uchar	*table_list[MAX_TYPE];				/* translation table			*/
uchar	*field_sep;							/* field separator				*/

uchar	*key_tag[RE_NREGS];					/* tag for key defined by -T#..	*/
int		key_tag_flag[RE_NREGS];				/* flag of tag for key in -T#.. */

char	fname[MAX_PATH];					/* name of temporal file		*/
char	*ptr_fname;							/* ptr to varible in fname[]	*/
char 	*filename = "";							/* name of current text			*/
char	*foutname;							/* name of output file			*/
char	*head;								/* header of paragraph			*/

#ifdef	UNIXPATH
char	switch_ch =	'/';					/* switch character in UNIX		*/
#else
char	switch_ch =	'\\';					/* switch character in MS-DOS	*/
#endif

int		room = 0x1000;						/* maximal length of a line		*/

int		paragraph;							/* sort by paragraphs			*/
int		uniq_key;							/* max key for unique (-u)		*/
int		f_atty;								/* flag for redirect of output	*/
int		f_eof;								/* flag for EOF					*/
int		f_err;								/* flag for error				*/
int		f_uniq;								/* flag for unique (-u)			*/
int		f_conc;								/* flag for concatenate opt (?)	*/
int		f_sort;								/* flag for type of sorting		*/
int		f_sum;								/* flag for summ (-H<kes>s/S)	*/
int		f_direct;							/* flag for non-sort (-D)		*/
int		f_head_only;						/* flag for non-output (-HC)	*/
int		f_re_cut;							/* flag for cut (-W)			*/
int		f_help;								/* flag for help messages		*/

#ifdef	JIS
  #ifdef EUC
int		f_jis = 0x444;						/* JIS or EUC					*/
  #else
int		f_jis = 0xaaa;						/* ShiftJIS						*/
  #endif
#endif

int		read_head;							/* size of header to read		*/
int		write_head;							/* size of header for write		*/
int		div0, div1, div2;					/* divided file numbers			*/
int		ord[4];								/* sort for units				*/
int		max_key;							/* number of keys				*/
int		max_key2;							/* copy of max_key				*/
int		top_key;							/* top of keys for sorting		*/
int		max_table;							/* number of translation table	*/
int		max_field;							/* number of fields defined		*/
int		max_re_para;						/* number of reg_exp of para	*/
int		head_exist = -1;					/* a key by -H<key>e			*/
int		head_e_type;						/* a key by -H<key>e			*/
int		head_uniq = -1;						/* a key by -H<key>u			*/
int		m_head = -1;						/* number of keys in -H			*/
int		head_u_type;						/* type of the key in -H<key>	*/
int		unit;								/* size of header in memory		*/
int		p_line = 1;							/* #lines for paragraph			*/
int		re_cut_pos;							/* block defined by -C<pos>		*/
int		files;								/* current file numbers			*/

SIZE	div_size;							/* size of buffer for a unit	*/
SIZE	left;								/* left bytes in buffer			*/
SIZE	max_parasize;						/* biggest size of a paragraph	*/
SIZE	line_current;						/* current top of paragraph		*/
SIZE	line_count;							/* #lines from the top of file	*/
SIZE	line_off;							/* #lines in former files		*/
SIZE	head_count;							/* #headers output				*/

struct re_registers re_sult;				/* result of search by re_exp	*/

int		uniq_o[MAX_KEY+1];					/* compare for unique using Re	*/
int		uniq_o_len[MAX_KEY+1];				/* length of string for uniq_o	*/

union	p_uniq {							/* compare (-u#[<>=]<string>)	*/
			uchar	*s;
			INT32	i;
			float	f;
			double	d;
		} p_uniq[MAX_KEY+1];

struct len {
			int	mi;
			int	ma;
		};

union	sum {
			struct len len;
			INT32	i;
			float	f;
			double	d;
		};

struct mHead {
			int	pos;
			int	type;
			uchar *head;
			uchar *form;
			union sum sum;
		} mHead[MAX_HEAD+1];

#ifdef	KANJI
 #ifdef	EUC
uchar	oblank[] = "\t \xa1\xa1\n";
 #else
uchar	oblank[] = "\t \x81\x40\n";
 #endif
#else
uchar	oblank[] = "\t \n";
#endif

#ifdef	RE_PARA
uchar	null_line[] = "^\n";				/* default paragraph separator */
#endif

uchar	pblank[] = "\n";
uchar	zero[]	= "0";
uchar	*blank	= oblank;
uchar	*para_sep = "\n";
int		para_sep_num = 1;
int		para_sep_len = 1;

uchar	def_tag[] = ":default";

struct re_pattern_buffer *re_para[MAX_PARA];			/* RE for paragraph */
struct re_pattern_buffer *re_pend;						/* RE for EOP		*/
struct re_pattern_buffer *re_cut;						/* RE for cut		*/

FILE	*fp_in;								/* input file			*/
FILE	*fp_out = stdout;					/* output for two steps */
FILE	*fp[4];								/* for the second step	*/


								/* F:field	R:RE  N:Number		*/
struct KEY {
	int		type[MAX_KEY+1];	/* flag of sort type 			*/

	int		data[MAX_KEY+1];	/* relative position of data -> */
								/* FR: (int)top, (int)len		*/
								/* N:   int32 | float | double	*/
	int		pos[MAX_KEY+1];		/* F(N): top field				*/
								/* R(N): position for ( ) in RE	*/
	int		bpos[MAX_KEY+1];	/* F(N): top shift by byte		*/
								/* R(N): former reference of RE	*/
	int		end[MAX_KEY+1];		/* F(N): end field				*/
								/* R(N): link of RE				*/
	int		bend[MAX_KEY+1];	/* F(N): end shift by byte		*/

	uchar*	trans[MAX_KEY+1];	/* FRN : translation table		*/

	struct re_pattern_buffer *re_buf[MAX_KEY+1];
								/* R   : RE pattern buffer		*/
} key;

int	ref_pos[MAX_KEY*2];
int	ref_key[MAX_KEY*2];

#ifdef	UNIXPATH
#define		PATH_SEP	':'
#else
#define		PATH_SEP	';'
#endif

static char		*psortrc[5];
#define		data_path0	psortrc[0]
#define		pager		psortrc[1]
#define		def_doc		psortrc[2]
#define		def_tbl		psortrc[3]
#define		def_cfg		psortrc[4]

/********************************************************************/
/*						flag of f_sort								*/

#define	F_NUMBER		0x0003
									/* used for Number */
 #define	F_STRING	0x0000
 #define	F_INT		0x0001
 #define	F_FLOAT		0x0002
 #define	F_DOUBLE	0x0003

#define	F_PNUM			0x0004		/* absolute value */

#define	F_SNUM			0x0008		/* special number for -T: */
#define	KEY_STYPE		(0x00b8|F_NUMBER)
 #define	S_ALL		(0x0008|F_STRING)
 #define	S_SIZE		(0x0008|F_INT)
 #define	S_LINE		(0x0018|F_INT)
 #define	S_COUNT		(0x0028|F_INT)
 #define	S_FILE		(0x0038|F_INT)
 #define	S_LINEN		(0x0088|F_INT)
 #define	S_LINET		(0x0098|F_INT)

#define	KEY_RTYPE		0x0030
									/* used for RE */
 #define	G_JUST		0x0000
 #define	G_TOEND		0x0010
 #define	G_SKIP		0x0020

#define	F_MODIFY		0x0700
									/* used for string */
 #define	F_SMALL		0x0100
 #define	F_PRINT		0x0200
 #define	F_ALNUM		0x0400

#define	F_KANJI			0x0800
#define	F_FIELD			0x1000
#define	F_CFRE			0x2000

#define	F_REVERSE		0x0040		/* reverse sort */

								/*** used for RE ***/
#define	F_CHECK			0x0080		/* check matching	*/
#define	F_LENGTH		0x4000		/* matching length	*/
#define	F_POS			0x8000		/* matching position */

								/*** used for fields ***/
#define	F_BLANK			0x0080		/* ignore blank */
#define	F_BLANKB		0x4000
#define	F_FIELDE		0x8000

/********************************************************************/
/*						flag of paragraph							*/

#define		P_FLG		0x0001
#define		P_TOP		0x1000
#define		P_DIV		0x2000
#define		P_MUL		0x4000
#define		P_CUT		0x0100
#define		P_CTOP		0x0200

/********************************************************************/
/*						flag of f_re_cut							*/

#define	G_CUT_REC	0x1000
#define	G_CUT_WHOLE	0x2000
#define	G_CUT_REV	0x4000

/********************************************************************/
/*						flag of f_conc								*/

#define	F_CONC		0x1000
#define	F_CKEY		0x2000
#define	F_CHEAD		0x4000
#define	F_CKEYGET	0x001f

/********************************************************************/
/*						flag of f_uniq								*/

#define	UNIQ_F			1
#define	UNIQ_U			2
#define	UNIQ_D			4
#define	UNIQ_N			8
#define	UNIQ_C			16
#define	UNIQ_H			0x1000
#define	UNIQ_E			0x2000
#define	UNIQ_O			0x4000

#define	UO_L			4
#define	UO_S			2
#define	UO_E			1
#define	UO_JTBL			0x1000

/********************************************************************/
/*						flag of mHead[].type						*/

#define	H_FORM			0x0f00
#define	H_NUMBER		0x0000
#define	H_STRING		0x0100
#define	H_FORMQ			0x0200
#define	H_LEFT			0x0400
#define	H_STRINGL		(H_STRING|H_LEFT)

#define	H_TYPE			0x0007
#define	H_SPECIAL		0x000c
#define	H_SPECIAL1		0x0004
#define	H_SPECIAL2		0x0008
#define	H_FILE			(H_SPECIAL1|F_STRING)
#define	H_COUNT			(H_SPECIAL1|F_INT)
#define	H_ORDER			(H_SPECIAL2|F_INT)

#define	H_SUM			0x0010
#define	H_IGNORE		0x0020

/********************************************************************/
/*						mode in get_opt()							*/

#define	O_COMMAND		0
#define	O_FILE			G_NEST
#define	O_FDEF			(G_NEST+1)
#define	O_RE			(G_NEST+2)
#define	O_FIELD			(G_NEST+3)

uchar *opt_err[] = {
	"command",
	"file",
	"last file",
	"default",
	"re_exp",
	"field"
	};
/********************************************************************/
/*						other definitions			 				*/

#ifdef  BUS_DBL
#define UNIT_GAP		(sizeof(double)-1)
#elif   BUS_FLT
#define UNIT_GAP		(sizeof(float)-1)
#else
#define	UNIT_GAP		(sizeof(int)-1)
#endif

#define	UNIT_PARA		sizeof(int)
#define	UNIT_INT		sizeof(INT32)
#define	UNIT_FLOAT		sizeof(float)
#define	UNIT_DOUBLE		sizeof(double)
#define	UNIT_STRING		2*sizeof(int)

#define	to_int(x)		*((int*)(x))
#define	to_int1(x)		*((int*)(x)+1)
#define	to_int32(x)		*((INT32*)(x))
#define	to_float(x)		*((float*)(x))
#define	to_double(x)	*((double*)(x))
#define	to_str(y,x)		(y+to_int(x))

#define	end_uniq()		writeoneline(NULL)

#define MSORT_RE (RE_INTERVALS | RE_NO_BK_CURLY_BRACES	   \
			| RE_NO_BK_VBAR | RE_NO_BK_PARENS 		   \
                        | RE_HAT_NOT_NEWLINE | RE_CHAR_CLASSES 		   \
                        | RE_NO_EMPTY_BRACKETS | RE_CONTEXTUAL_INVALID_OPS \
                        | RE_NO_EMPTY_RANGES 		   \
                        | RE_NO_HYPHEN_RANGE_END)


/********************************************************************/
/*						Help messages for options			 		*/

static char msg_usg[] =
"Usage:  psort [options] [[@]text...] [< in] [> out]\n";

static char	msg[] =

"\t<<< P-Sort(" K_TYPE ")  Ver " VERSION " >>>    by SHIMA, 1994-96\n"
"\n"
"%s\n"
"-b  ignore blank		 "
	"-P[m][v][t][:<re_exp>] -P<number> -p[<re_exp>]\n"

"-i  printable character		 "
	"-Q[e]:<re_exp>		      define paragraph\n"

"-f  ignore case\n"

"-d  alphabets & figures		 "
	"-S[[+|-]<pos>][<options>]:<re_exp> -s<re_exp>\n"

"-j  ignore 2 byte characters	 "
		"-T[[+|-]<pos>][<options>][:<key>]  define key\n"

"-n  float\n"

"-N  double float		 "
		"+<pos>[.<shift>][<options>]\n"

"-z  integer			 "
		"-<pos>[.<shift>][b]\n"

"-U  ignore sign			 "
		"=<pos>[.<shift>][<options>]	 define fields\n"

"-r  reverse\n"

"-D  no sorting			 "
		"-u[U][D][N][.]  -u#<tag>[<>=]<string>	unique\n"

"-h[0]  help/record messages	 "
		"-t<string>	field separators\n"

"-q<string>  make paragraph	 "
		"-$<string>	head of temporary file\n"

"-o<file>    output <file>	 "
		"-J[<file>]	define order by <file>\n"

"-H[C][<key>[e][u][s][S][/<key>...]][:<string>]	header of paragraph\n"

#ifdef	JIS
"-K[$<c>][(<c>][7][J|j|E|S|s|Q|q|:][...][...]	JIS/EUC/SJIS/?"
#ifdef	EUC
	"(default: JIS/EUC)\n"
#else
	"(default: SJIS)\n"
#endif
#endif

"-C[[+|-]<pos>][r|w|W]:<re_exp>	 cut strings\n"

"-[g[<file>]][:<label>]		 read options from <file>\n"

"-L<length>			 maximal length of a line(defalt: 4096)\n"

#ifndef	MSDOS
"-M<size>			 <size> K byte of memory(defalt: 1024K)\n"
#endif
;

/********************************************************************/

static void set_reg( struct re_pattern_buffer **, uchar *, uchar *);

static void
oputs(uchar *s)
{
	FILE *fp;
#ifdef	SJIS
	uint tmp;
#endif

	fp = fp_out;
	fp_out = stdout;
#ifdef	SJIS
	tmp = f_jis;
	f_jis &= ~JO_CR;
#endif
	f_err |= Fputs(s);
	fp_out = fp;
#ifdef	SJIS
	f_jis = tmp;
#endif
}

static void
mputs(uchar *s)
{
	if(f_help >= 0){
		fprintf(stderr, s);
		if(f_help && !f_atty){
			putc('\t', stdout);
			oputs(s);
		}
	}
}

static void
make_table( pt, flag )
uchar **pt;
int flag;
{
	int	i, ch, type;
	uchar *table;

	type = (flag >> 8) & 7;
	for(i = 0; i < max_table; i++){
		if(table_list[i][USIZE] == type)
		*pt = table_list[i];
		return;
	}
	*pt = table_list[max_table++] = table = (uchar*)xmalloc(USIZE+1);
	table[USIZE] = type;
	for(i = 0; i < USIZE; i++ ){
		ch = i;
		if(flag & F_PRINT){
			if(!isprint(ch) && !isspace(ch))
				ch = 0;
		}
		if(flag & F_ALNUM){
			if(!isalnum(ch) && !isspace(ch))
				ch = 0;
		}
		if(flag & F_SMALL){
			if(isupper(ch))
				ch = tolower(ch);
		}
		table[i] = ch;
	}
}

static int
strmcmp( str1, str2, len1, len2, tbl
#ifdef	KANJI
, f_Kskip
#endif
)
uchar *str1, *str2, *tbl;
int len1, len2;
{
	int	ch1, ch2;
	while(len1 > 0 && len2 > 0){
#ifdef	KANJI
		if(iskanji(*str1)){
			if(f_Kskip){
				str1 +=2;
				len1 -=2;
				continue;
			}else{
				ch1 = (*str1++ - 0x80) << 8;		/* same as JIS code */
				ch1 += *str1;
				len1--;
			}
		}else
#endif
		{
			if(!(ch1 = tbl[*str1])){
				str1++;
				len1--;
				continue;
			}
		}
cnt:
#ifdef	KANJI
		if(iskanji(*str2)){
			if(f_Kskip){
				str2 += 2;
				if((len2 -= 2) <= 0) break;
				goto cnt;
			}else{
				ch2 = (*str2++ - 0x80) << 8;	/* same as JIS code */
				ch2 += *str2;
				len2--;
			}
		}else
#endif
		{
			if(!(ch2 = tbl[*str2])){
				str2++;
				if((--len2) <= 0) break;
				goto cnt;
			}
		}
		if(ch1 != ch2) return ch1 - ch2;
		len1--; len2--; str1++; str2++;
	}
	return len1 - len2;
}


static int
compare( str1, str2 )
uchar *str1, *str2;
{
	int	i, len1, len2, len, result, rev;
	char *s1, *s2;

	for(i=top_key;i<max_key;i++){
		rev = 1 - (key.type[i] & F_REVERSE);
		s1 = str1 + key.data[i];
		s2 = str2 + key.data[i];
		switch(key.type[i] & F_NUMBER){
			case F_STRING:							/* sort as strings */
				len1 = to_int1(s1);
				len2 = to_int1(s2);
				len = (len1<len2)?len1:len2;
				if(!(key.type[i] & F_MODIFY)){		/* without option */
					if(j_table == NULL || (uniq_o[i] & UO_JTBL)){
						result = 
							MemCmp(to_str(str1, s1), to_str(str2, s2), len);
						if(result < 0)  return -rev;
						if(result > 0 )  return  rev;
						if(len1==len2)	continue;
						return (len1<len2)? -rev:rev;
					}else{
						result = strjcmp(to_str(str1, s1), to_str(str2, s2),
							len1, len2);
						if(result + uniq_o_len[i] < 0) return -rev;
						if(result > uniq_o_len[i]) return rev;
						continue;
					}
				}else{									/* with option */
					result = strmcmp(to_str(str1, s1), to_str(str2, s2), len1, 
						len2, key.trans[i]
#ifdef	KANJI
						, key.type[i] & F_KANJI
#endif
					);
					if      (result < 0) return -rev;
					else if (result > 0) return  rev;
					continue;
				}

			case F_INT:
				if(to_int32(s1) > to_int32(s2))
					return rev;
				if(to_int32(s1) < to_int32(s2))
					return -rev;
				continue;

			case F_FLOAT:
				if(to_float(s1) > to_float(s2))
					return rev;
				if(to_float(s1) < to_float(s2))
					return -rev;
				continue;

			case F_DOUBLE:
				if(to_double(s1) > to_double(s2))
					return rev;
				if(to_double(s1) < to_double(s2))
					return -rev;
				continue;
		}
	}
	return 0;
}


static void
makehead(ptr, len)
uchar *ptr;
int	len;
{
	int	i, k, x, y, z, pos;
	uchar *s, *t, *u, *p, *v, *w;
	static uint count;

	count++;
	len--;
	s = t = u = v = ptr + unit;

	for(i=x=z=0; i<max_field; i++){
		k = ref_key[i];
		y = ref_pos[i];
		if(y > x){
			if(!x){						/* to the first field */
				x = 1;
				if(!field_sep){
					t = StrSkip(t, blank);
					if(t)
						t = v = StrPbrk(t, blank);
					if(t)
						t = StrSkip(t, blank);
				}else{
					t = v = StrPbrk(t, field_sep);
					if(t){
#ifdef	KANJI
						if(iskanji(*t) && t[1])	t++;
#endif
						t++;
					}
				}
			}
		}
		for( ;y > x && t != NULL; x++){
			if(!field_sep){
				if((t = v = StrPbrk(t, blank)) != NULL)
					t = StrSkip(t, blank);
			}else{
				t = v = StrPbrk(t, field_sep);
				if(t){
#ifdef	KANJI
					if(iskanji(*t) && t[1])	t++;
#endif
					t++;
				}
			}
		}
		x = y;
		p = ptr+key.data[k & 0x7f];
		if(k & 0x80){
			k &= 0x7f;
			if(key.type[k] & F_BLANKB){
				if(y != z){
					z = y;
					u = StrSkip(t, blank);
				}
				if(u!=NULL){
					pos = u - s + key.bend[k];
					goto set2;
				}
				else
					goto non2;
			}else{
				if(t!=NULL){
					pos = ((key.bend[k]==MAX_INT)?v:(t+key.bend[k])) - s;
set2:				if(pos >= len) goto non2;
					pos -= (to_int(p) - unit);
					to_int1(p) = (pos > 0)? pos:0;
				}else{
non2:				to_int1(p) = (to_int1(p))? (len+unit-to_int(p)):0;
				}
			}
		}else{
			if(key.type[k] & F_BLANK){
				if(y != z){
					z = y;
					u = StrSkip(t, blank);
				}
				if(u!=NULL){
					pos = u-s;
					goto set;
				}else
					goto non;
			}else{
				if(t!=NULL){
					pos = t-s;
set:				pos += key.bpos[k];
					if(pos >= len) goto non;
					if(key.type[k] & F_NUMBER){
						w = StrSkip(s+pos, blank);
						if(*w == '-' && (key.type[k] & F_PNUM))
							w++;
						switch(key.type[k] & F_NUMBER){
							case F_INT:
								to_int32(p) = atol(w);
								break;

							case F_FLOAT:
								to_float(p) = atof(w);
								break;

							case F_DOUBLE:
								to_double(p) = atof(w);
								break;
						}
					}else{
						to_int(p)  = pos + unit;
						to_int1(p) = len - pos;
					}
				}else{
non:				switch(key.type[k] & F_NUMBER){
						case F_STRING:
							to_int(p)  = unit + len;
							to_int1(p) = 0;
							break;

						case F_FLOAT:
							to_float(p) = 0;
							break;

						case F_INT:
							to_int32(p) = 0;
							break;

						case F_DOUBLE:
							to_double(p) = 0;
							break;
					}
				}
			}
		}
	}

	for(i=0;i<max_key ;i++){
		if(!key.re_buf[i]){
			p = ptr + key.data[i];
			switch(key.type[i] & KEY_STYPE){
				case S_ALL:
					to_int(p)  = unit;
					to_int1(p) = len;
					continue;

				case S_SIZE:
					to_int32(p) = len+1;
					continue;

				case S_LINE:
					to_int32(p) = (paragraph)?to_int(ptr):p_line;
					continue;

				case S_LINEN:
					to_int32(p) = line_current;
					continue;

				case S_LINET:
					to_int32(p) = line_current + line_off;
					continue;

				case S_COUNT:
					to_int32(p) = count;
					continue;

				case S_FILE:
					to_int32(p) = files;
					continue;

				default:
					continue;
			}
		}
		z = re_search(key.re_buf[i], s, len, 0, len, &re_sult);
		k = i;
		do{
			p = ptr + key.data[k];
			x = key.type[k];
			pos = key.pos[k];
		  	if(z >= 0 && re_sult.end[pos] >= 0){
				t = s + (((x & KEY_RTYPE) == G_SKIP)?
				re_sult.end[pos]:re_sult.start[pos]);
				if(x & F_NUMBER){					/*** number ***/
					if(x & F_CHECK){				/* special RE */
						if(x & F_POS){
							to_int32(p)=((x & KEY_RTYPE) == G_SKIP)?
								 re_sult.end[pos]:re_sult.start[pos];
						}else{
							if((x & KEY_RTYPE) == G_JUST){
								to_int32(p) = re_sult.end[pos]
											 - re_sult.start[pos];
							}else
								to_int32(p) = len - (t-s);
							if( !(x & F_LENGTH) && to_int32(p))
									to_int32(p) = 1;
						}
					}else{							/* usual number */
						w = StrSkip(t, oblank);
						if(*w == '-' && (x & F_PNUM))
							w++;
						switch(x & F_NUMBER){
							case F_INT:
								to_int32(p) = atol(w);
								break;

							case F_FLOAT:
								to_float(p) = atof(w);
								break;

							case F_DOUBLE:
								to_double(p) = atof(w);
								break;
						}
					}
				}else{								/*** string ***/
					to_int(p) = (t-s) + unit;
					if((x & KEY_RTYPE) == G_JUST){
						to_int1(p) = 
						re_sult.end[pos]-re_sult.start[pos];
					}else
						to_int1(p) = len - (t-s);
				}
			}else{									/*** no match ***/
				switch(x & F_NUMBER){
					case F_STRING:
						to_int(p)  = unit + len;
						to_int1(p) = 0;
						break;

					case F_FLOAT:
						to_float(p) = 0;
						break;

					case F_INT:
						to_int32(p) = 0;
						break;

					case F_DOUBLE:
						to_double(p) = 0;
				}
			}
		}while((k = key.end[k]) != 0);
	}
}

static int
getline( dest )
BUFFER *dest;
{
	BUFFER *top;
	int	len, count, ss , ch;

start:
	if(fgets(dest, room, fp_in) == NULL){
		line_off += line_count;
		line_count = 0;
		return 0;
	}
#ifdef	JIS
	if(f_jis && 
#ifdef	EUC
		(count = to_euc(dest,room)) != 0
#else
		(count = to_euc(dest)) != 0
#endif
		){
		switch(count){
			case 1:
				top = "Misunderstood or wrong JIS code\n";
				break;

			case 2:
				top = "Too long line\n";
				break;

			default:
				top = "Failed to distinguish JIS from "
#ifdef	EUC
				"EUC\n";
#else
				"ShiftJIS\n";
#endif
		}
		fputs(top, stderr);
		exit(2);
	}
#endif
	line_count++;
	len = strlen(dest);
	if(!len || dest[len-1] != '\n'){
		mputs("[Insert EOL]\n");
		dest[len++] = '\n';
		dest[len] = 0;
	}
	if(!f_re_cut)
end:	return(len);
rep:
	if(re_search(re_cut, dest, len, 0, len, &re_sult) < 0){
		if(!(f_re_cut & G_CUT_REV))
			goto end;
c_out:	if(!f_atty && !(paragraph & P_CUT))
			oputs(dest);
		goto start;
	}
	if(f_re_cut & G_CUT_WHOLE){
		if(f_re_cut & G_CUT_REV)
			goto end;
		goto c_out;
	}
	switch(f_re_cut & KEY_RTYPE){
		case G_JUST:
			top = dest + re_sult.start[re_cut_pos];
			count = re_sult.end[re_cut_pos] - re_sult.start[re_cut_pos];
			if(count >= len)					/* cut the whole line */
				goto c_out;
			if(count <= 0)
				goto end;
			len -= count;
			ss = len - (top - dest) + 1;
			if( ss > 0 ){
				if(!f_atty && !(paragraph & P_CUT)){
					ch = *(top+count);
					*(top+count) = 0;
					oputs(top);
					putc('\n', stdout);
					*(top+count) = ch;
				}
				memmove(top, top + count, ss);
			}
			if(f_re_cut & G_CUT_REC)
				goto rep;
			break;

		case G_TOEND:
			top = dest + re_sult.start[re_cut_pos];
			goto ct;

		case G_SKIP:
			top = dest + re_sult.end[re_cut_pos];
ct:			if(*top != '\n'){
				if(!f_atty && !(paragraph & P_CUT))
					oputs(top);
				*top = 0;
			}

		default:
			break;
	}
	len = strlen(dest);
	if(!len || dest[len-1] != '\n'){
		dest[len++] = '\n';
		dest[len] = 0;
	}
	return len;
}


static int
readparae(count)
int count;
{
	int			len, paracount, p_last, done, gap, match, i;
	SIZE		pos, pos0, parasize;
	BUFFER		*temp;

	parasize = p_last = done = gap = match = 0;
	pos = ftell(fp_in);
	lptr[count] = text;

	paracount = -1;
	text += unit;
	left -= unit + 1;

	while ( (len = getline( temp = text + p_last )) != 0 ){
		if(!done){
			if(paragraph & P_CUT){
				if(re_search(re_pend, temp, len, 0, len, &re_sult) >= 0){
					done = 1;
					if(paragraph & P_CTOP) goto cut;		/* cut */
				}else{
cut:				if(!f_atty)	oputs(temp);
					continue;
				}
			}else
				done = 1;
		}
		if(!++paracount)
			line_current = line_count;
		if(p_last)
			lptr[count+1] = text;
		left -= len;
		if(len >= room-1){
			fputs("Too long line\n", stderr);
			exit(2);
		}
#ifndef	RE_PARA
		if(!max_re_para){
			if(*temp == '\n')	goto fd;
			else			goto nfd;
		}else
#endif
check:	if( i = (match<max_re_para)?match:(max_re_para-1), 
		  re_para[i] == NULL ||
		  re_search(re_para[i], temp, len, 0, len, &re_sult) >= 0){
fd:			if(++match == p_line){
				p_last =  unit;				/* maybe the EOP */
			}else if(match > p_line){
				if(paragraph & P_DIV){		/* the TOP */
					match = 1;
					if(p_line > 1)
						p_last = 0;			/* not the EOP */
					goto top;
				}
				memmove(text -= gap, temp, len + 1);	/* not the TOP */
				left += gap;
			}
		}else{
			if(match && match < p_line){
				match = 0;
				goto check;
			}
nfd:		match = 0;
			if(p_last){
				p_last = 0;
top:			to_int(lptr[count]) = paracount;	/* TOP of paragraph */
				makehead(lptr[count++], parasize);
				line_current = line_count;
				if(max_parasize < parasize)
					max_parasize = parasize;
				pos = pos0;
				parasize = paracount = 0;
				left -= unit + 1;
				text += unit;

				if(paragraph & P_CUT){
					if(re_search(re_pend, temp, len, 0, len, &re_sult) >= 0){
						if(paragraph & P_CTOP){
							paracount = -1;
							goto cut;
						}
					}else{
						p_last = done = 0;
						paracount = -1;
						continue;
					}
				}
			}
		}
		parasize += len;
#ifdef	MSDOS
		(HUGEBUF*)text += len - 1;
		text++;
#else
		(HUGEBUF*)text += len;
#endif
		if(p_last){
			gap = UNIT_GAP & ~(text - tex0);
			left -= gap;
			text += ++gap;
			pos0 = ftell(fp_in);
		}
		if(left < room || count >= max_line || paracount == MAX_INT){
full:		if(count < 2){
				fputs("Too long paragraph\n", stderr);
				exit(2);
			}
			fseek(fp_in, pos, 0);
			return count;
		}
	}

	f_eof = 1;
	if(done){
		left--;
		if(match < p_line){				/* no ID at end of the paragraph */
			mputs("[Insert paragraph separator at the end]\n");
			if(para_sep_num > 1)
				match = p_line - 1;
			while(match++ < p_line){
				parasize += para_sep_len;
				if( (left -= para_sep_len) <= 0 ){
					f_eof = 0;
					goto full;
				}
				strcpy(text-1, para_sep);
				text += para_sep_len;
				paracount += para_sep_num;
			}
		}
		to_int(lptr[count]) = paracount + 1;
		makehead(lptr[count++], parasize);
		if(max_parasize < parasize)
			max_parasize = parasize;
	}
	fclose(fp_in);
	return count;
}


static int
readparat(count)
int count;
{
	int				len, paracount, done, gap, match, i;
	SIZE			pos, pos0, parasize, para0, line0;
	HUGEBUF*		pt_top;

	parasize = para0 = paracount = done = gap = match = 0;
	pos0 = ftell(fp_in);
	left -= unit + 1;
	lptr[count] = (BUFFER*)pt_top = text;
	text += unit;

	while ( (len = getline( text )) != 0 ){
		if(!paracount++)
			line_current = line_count;
		left -= len;
		if(len >= room-1){
			fputs("Too long line\n", stderr);
			exit(2);
		}
#ifndef	RE_PARA
		if(!max_re_para){
			if(*text == '\n')	goto fd;
			else				goto nfd;
		}else
#endif
check:	if(i = (match<max_re_para)?match:(max_re_para-1),
		  re_para[i] == NULL || 
		  re_search(re_para[i], text, len, 0, len, &re_sult) >= 0){
												/* top part of paragraph? */
fd:			if(!match){							/* first line of paragraph */
				pt_top = text;
				para0 = parasize;
				pos = pos0;
				line0 = line_count;
			}
			if(++match != p_line) goto cnt;		/* continue	*/

			if(!done){							/* top part */
				done = 1;
				goto cnt;
			}

top:		gap = (~(pt_top - tex0) & UNIT_GAP) + 1;	/* make header */
			if(done){
				memmove(pt_top + unit + gap, pt_top, 
					(HUGEBUF*)text - (HUGEBUF*)pt_top + len + 1);
				*pt_top = 0;
			}
			lptr[count+1] = (BUFFER*)pt_top + gap;
			text += unit + gap;
			left -= unit + gap;
			to_int(lptr[count]) = paracount - match;
			makehead(lptr[count++], para0);
			line_current = line0;
			if(max_parasize < para0)
				max_parasize = para0;
			parasize -= para0;
			paracount = match;
			if(!done)	continue;
tpf:		done = 1;
			if((paragraph & P_DIV) != 0)
				match = 0;
		}else{
			if(match && match < p_line){
				match = 0;
				if(!done && !f_atty && (paragraph & P_CUT)){
					i = *text;
					*text = 0;
					oputs((uchar *)pt_top);
					*text = i;
				}
				goto check;
			}
nfd:		match = 0;
			if(!done){
				if(paragraph & P_CUT){				/* cut a line */
					left += len + parasize;
					paracount = parasize = 0;
					if(!f_atty)	oputs(text);
					text = lptr[count] + unit;
					continue;
				}
				mputs("[Insert paragraph separator at the top]\n");
				if(para_sep_num > 1)
					match = p_line - 1;
				while(match++ < p_line){
					if((left -= para_sep_len) <= room)
						goto full;
					paracount += para_sep_num;
					memmove(text + para_sep_len, text, len + 1);
					memmove(text, para_sep, para_sep_len);
					parasize += para_sep_len;
					text += para_sep_len;
				}
				goto tpf;
			}
			else if(paragraph & P_CUT){
				if(re_search(re_pend, text, len, 0, len, &re_sult) >= 0){
					done = 0;
					if(!(paragraph & P_CTOP)){		/* cut a line */
						if(!f_atty)
							oputs(text);
						left += len;
						paracount--;
						*text = len = 0;
					}
					para0 = parasize += len;
					pt_top = (text += len);
					goto top;
				}
			}
		}
cnt:
#ifdef	MSDOS
		(HUGEBUF*)text += len - 1;
		text++;
#else
		(HUGEBUF*)text += len;
#endif
		parasize += len;
get_pos:
		pos0 = ftell(fp_in);
		if(left < room || count >= max_line || paracount == MAX_INT){
full:		if(count < 2){
				fputs("Too long paragraph\n", stderr);
				exit(2);
			}
			fseek(fp_in, pos, 0);
			return count;
		}
	}

	f_eof = 1;
	if(done){
		left--;
		to_int(lptr[count]) = paracount;
		makehead(lptr[count++], parasize);
		line_current = 0;
		if(max_parasize < parasize)
			max_parasize = parasize;
	}
	fclose(fp_in);
	return count;
}


int
readdata( count )
int	count;
{
	int		len, shift, line, init, gap;
	SIZE	pos, left0, para_size;

	if(paragraph)
		return (paragraph & P_TOP)?readparat(count):readparae(count);

	init = 0;
	while ( (len = getline( text + unit )) != 0 ){
		line_current = line_count;
		left0 = left;
		len += unit + 1;
		lptr[count] = text;
		left -= len;
		if(len - unit >= room){
			fputs("Too long line\n", stderr);
			exit(2);
		}
		(HUGEBUF*)text += len - 1;
		for(line=0; line < p_line; line++ ){
			if ( ( left < room ) || ( count >= max_line ) ){
				if(line){
					if(!init){
						fputs("Too long paragraph\n", stderr);
						exit(2);
					}
					fseek(fp_in, pos, 0);
				}
				return	count;
			}
			if(!line)
				continue;
			if(fgets( text, room, fp_in ) == NULL){
				mputs("[Insert paragraph separator]\n");
				strcpy(text, para_sep);
			}
			len = strlen(text);
			left -= len;
			(HUGEBUF*)text += len;
			if(len - unit >= room){
				fputs("Too long line\n", stderr);
				exit(2);
			}
		}
		if((para_size = (left0 - left)) > max_parasize)
			max_parasize = para_size;
		gap = ~(text - tex0) & UNIT_GAP;
		left -= gap;
		text += gap + 1;
		if(p_line != 1)
			pos = ftell(fp_in);
		makehead(lptr[count++], para_size - unit - 1);
		init++;
	}
	fclose( fp_in );
	f_eof = 1;
	return	count;
}

static void
put_string( uchar *s, struct mHead *mh )
{
	uchar *t;
	int	len, mlen, ch;

	mlen = mh->sum.len.ma;
	if(mlen == 0)
		mlen = -1;
#ifdef	KANJI
	for(len = 0, t = s; *t; t++){
 #ifdef	EUC
		if(*t == EUC_KANA && *(t+1)){
			t++;
		}else 
 #endif
		if(iskanji(*t) && *(t+1)){
			if(++len == mlen)
				break;
			t++;
		}
		if(++len == mlen)
			break;
	}
#else
	len = strlen(s);
	if(mlen > 0 && len > mlen)
		len = mlen;
#endif
	t = s + len;

	if(!(mh->sum.len.mi) || mh->sum.len.mi < len || *t){
		ch = *t;
		if(ch) *t = 0;
		f_err |= Fputs(s);
		if(ch) *t = ch;
		return;
	}

	len = mh->sum.len.mi - len;
	if(mh->type & H_LEFT){
		f_err |= Fputs(s);
		while(len--) putc(' ', fp_out);
	}else{
		while(len--) putc(' ', fp_out);
		f_err |= Fputs(s);
	}
}

static void
writehead( s, count )
uchar *s;
SIZE  count;
{
	int		ch, i, pos;
	SIZE	value;
	uchar 	*t, *u;

	if(head_exist >= 0){
		u = s + head_exist;
		switch(head_e_type){
			case F_STRING:
				if(to_int1(u) == 0)	return;
				break;

			case F_INT:
				if(to_int32(u) == 0) return;
				break;

			case F_FLOAT:
				if(to_float(u) == 0) return;
				break;

			case F_DOUBLE:
				if(to_double(u) == 0) return;
				break;
		}
	}

	head_count++;
	for(i = 0; i < m_head; i++){
		if(!(mHead[i].type & H_IGNORE))
			Fputs(mHead[i].head);
		u = s + mHead[i].pos;
		switch(mHead[i].type & (H_SPECIAL|F_NUMBER)){
			case F_STRING:
				if(mHead[i].type & H_FORMQ){			/* %p */
					fprintf(fp_out, mHead[i].form, u);
					continue;
				}										/* %s */
				t = to_str(s, u);
				u = t + to_int1(u);
					ch = *u;
					*u = 0;
					put_string(t, &mHead[i]);
					*u = ch;
					continue;

				case F_INT:
					value = to_int32(u);
					if(mHead[i].type & H_SUM){
						mHead[i].sum.i += value;
						if(mHead[i].type & H_IGNORE) continue;
					}
put_int:			if(mHead[i].type & H_STRING){
						sprintf(reg_buf, INT_OUT, value);
put_str:				put_string(reg_buf, &mHead[i]);
						continue;
					}
					fprintf(fp_out, mHead[i].form, value);
					break;

				case F_FLOAT:
					if(mHead[i].type & H_SUM){
						mHead[i].sum.f += to_float(u);
						if(mHead[i].type & H_IGNORE) continue;
					}
					if(mHead[i].type & H_STRING){
						sprintf(reg_buf, "%g", to_float(u));
						goto put_str;
					}
					fprintf(fp_out, mHead[i].form, to_int32(u));
					break;

				case F_DOUBLE:
					if(mHead[i].type & H_SUM){
						mHead[i].sum.f += to_double(u);
						if(mHead[i].type & H_IGNORE) continue;
					}
					if(mHead[i].type & H_STRING){
						sprintf(reg_buf, "%lg", to_double(u));
						goto put_str;
					}
					fprintf(fp_out, mHead[i].form, to_double(u));
					break;

				case H_FILE:
					put_string(filename, &mHead[i]);
					continue;

				case H_COUNT:
					value = count;
					goto put_int;

				case H_ORDER:
					value = head_count;
					goto put_int;
			}
	}
	Fputs(mHead[m_head].head);
}

static int
samehead(push_uniq, top)
uchar *push_uniq;
uchar *top;
{
	uchar *s, *t;
	int	i;

	if(push_uniq == NULL || top == NULL)
		return 0;

	s = push_uniq + head_uniq;
	t = top       + head_uniq;

	switch(head_u_type){
		case F_STRING:
			i = to_int1(s);
			if(to_int1(t) != i ||
			  MemCmp(to_str(push_uniq, s), to_str(top, t), i))
				return 0;
			break;

		case F_INT:
			if(to_int32(s) != to_int32(t))
				return 0;
			break;

		case F_FLOAT:
			if(to_float(s) != to_float(t))
				return 0;
			break;

		case F_DOUBLE:
			if(to_double(s) != to_double(t))
				return 0;
			break;
	}
	return 1;
}


static void
writeoneline( top )
uchar *top;
{
	int	i, j, k;
	static SIZE count;
	static int f_same_head;
	static uchar *push_uniq;
	uchar *s;

	if(f_uniq & UNIQ_O){						/* -u# option */
		for(k = 1; k < top_key; k++){
			s = top + key.data[k];
			j = 0;
			switch(key.type[k] & F_NUMBER){
				case F_STRING:
					if(!(key.type[k] & F_MODIFY)){
						if(j_table == NULL){
							j = MemCmp(to_str(top, s), p_uniq[k].s, 
								uniq_o_len[k]);
							if(j == 0)
								j = to_int1(s) - uniq_o_len[k];
						}else
							j = strjcmp(to_str(top, s), p_uniq[k].s, 
								to_int1(s), uniq_o_len[k]);
					}else{
						j = strmcmp(to_str(top, s), p_uniq[k].s, to_int1(s), 
							uniq_o_len[k], key.trans[k]
#ifdef	KANJI
							, key.type[k] & F_KANJI
#endif
							);
					}
					break;

				case F_INT:
					if(to_int32(s) > p_uniq[k].i)
						j = 1;
					else if(to_int32(s) < p_uniq[k].i)
						j = -1;
					break;

				case F_FLOAT:
					if(to_float(s) > p_uniq[k].f)
						j = 1;
					if(to_float(s) < p_uniq[k].f)
						j = -1;
					break;

				case F_DOUBLE:
					if(to_double(s) > p_uniq[k].d)
						j = 1;
				if(to_double(s) < p_uniq[k].d)
					j = -1;
				break;
			}
			if(j == 0){
				if(!(uniq_o[k] & UO_E))	return;
			}else if(j > 0){
				if(!(uniq_o[k] & UO_L))	return;
			}else
				if(!(uniq_o[k] & UO_S))	return;
		}
	}

	if(write_head){						/* output to a temporary file */
		for(i=0;i<write_head;i++){
			putc( (*(top + i) & 0xf)+ '0', fp_out );
			putc( (*(top + i) >> 4) + '0', fp_out );
		}
	}else if(f_uniq & UNIQ_F){							/* -u option */
		if(push_uniq != NULL){							/* push exists */
			if(top != NULL){
				max_key = uniq_key;
				i = compare(top, push_uniq);
				max_key = max_key2;
				if((f_uniq & (UNIQ_U|UNIQ_D)) != (UNIQ_U|UNIQ_D)){
					if(!i){								/* same */
						count++;
						return;
					}
				}else if(!i){
						count++;
						f_same_head = 1;
				}
				else	f_same_head = 0;
				i = (i)?0:1;
			}else
				i = 0;
			if( count == 1 ){
				if( f_uniq & UNIQ_D ) goto skp;
			}else if( count > 1 && (f_uniq & (UNIQ_U|UNIQ_D)) == UNIQ_U )
				goto skp;
			if( (f_uniq & (UNIQ_N|UNIQ_H)) == UNIQ_N )
				f_err |= fprintf(fp_out, INT_OUT "\t", count-i);
			if(head && !f_same_head)
				writehead(push_uniq, count-i);
			if(!f_head_only)
				f_err |= Fputs(push_uniq + unit);
			if(f_uniq & UNIQ_H)
				f_same_head = samehead(push_uniq, top);
		}
skp:	if(top == NULL)	return;		/* push to compare the following data  */
		if(!f_same_head)
			count = 1;
push:	if(f_uniq & UNIQ_C){
			memmove(push_uniq = tex[4], top, unit);
			strcpy(push_uniq + unit, top + unit);
		}else
			push_uniq = top;
		return;
	}else if(f_uniq & UNIQ_H){			/* -H<pos>u option */
		if(top == NULL)	return;
		count++;
		if(samehead(push_uniq, top))
			goto out_put;
		writehead(top, count);
		if(!f_head_only)
			f_err |= Fputs( top + unit );
		goto push;
	}else if(head)						/* no "unique" option */
			writehead(top, ++count);
out_put:
	if(write_head)
		f_err |= fputs( top + unit, fp_out );
	else if(!f_head_only)
		f_err |= Fputs( top + unit );
}

void
writedata( num )
int		num;
{
	int		i;

	for ( i = 0; i < num; i++ )
		writeoneline( lptr[i] );
}

static void
makename( num )
int	num;
{
	stci_d( ptr_fname, num );
}


static void
set_reg( re, s, tbl )
struct re_pattern_buffer **re;
uchar *s, *tbl;
{
	char *r;
	int	len;

	modify_reg(s, 1);
	*re =
		(struct re_pattern_buffer*)xmalloc(sizeof(struct re_pattern_buffer));
	(*re)->buffer = (char *) xmalloc(RE_msize);
	(*re)->allocated = RE_msize;
	(*re)->fastmap = (char *) xmalloc(1 << BYTEWIDTH);
	(*re)->translate = tbl;
 	if ((r = re_compile_pattern(reg_buf, strlen(reg_buf), *re)) != NULL) {
		fprintf(stderr, "%s.\n", r);
		exit(3);
	}
}


int
modify_reg( s , mode )
uchar *s;
int	mode;
{
	int	ch, c, pos;

#ifdef	JIS
	reg_buf[REG_size - 1] = 0;
	strncpy(reg_buf, s, REG_size);
	if(reg_buf[REG_size - 1])
		goto too_long;
	if(f_jis && 
#ifdef	EUC
		(c = to_euc(reg_buf, REG_size)) != 0
#else
		(c = to_euc(reg_buf)) != 0
#endif
		){
		if(c == 2)
			goto too_long;
		fprintf(stderr, "Bad code in %s expression\n", 
			(mode)?"regular":"string");
		exit(4);
	}
#endif
	if(mode == 2)
		return 0;
	for(pos = 0; (ch = *s++) != 0; ){
		if(ch == '\\'){
			switch(*s){
				case '0':
					for(c=ch=0; c < 3; c++){
						if(isdigit(*++s))
							ch = (ch << 3) + *s - '0';
						else{
							s--;
							break;
						}
					}
					break;

				case 'x':
				case 'X':
					ch = (((c = *++s)>'9')? (tolower(c)-('a'-10)):(c-'0'))<<4;
					ch += ((c = *++s)>'9')? (tolower(c)-('a'-10)):(c-'0');
					break;

				case 's':
					ch = ' ';
					break;

				case 't':
					ch = '\t';
					break;

				case 'n':
					ch = '\n';
					break;

				case 0:
				default:
					s--;
					break;
			}
			s++;
		}
		reg_buf[pos++] = ch;
too_long:
		if(pos >= REG_size-1){
			fprintf(stderr, "Too long %s expression\n",
				(mode)?"regular":"string");
			exit(4);
		}
	}
	reg_buf[pos] = 0;
	return pos;
}

void
skip_digit( s )
uchar **s;
{
	while(isdigit(**s))
		*s += 1;
}


static int
define_key( para )
uchar *para;
{
	int	count;
	uchar *s;
	uchar *t;

	t = strdup(para);
	for( count = 0; t && *t; ){
		s = t;
		if(  count >= RE_NREGS
		  || (key_tag_flag[count] = *s++ - '0') < 0
		  || key_tag_flag[count] > F_NUMBER
		  || !*s )
			return 0;
		if( (t = StrChr(key_tag[count++] = s, ':')) != NULL )
			*t++ = 0;
	}
	return count;
}

static int
get_key( para )
uchar *para;
{
	int	count, flag;

	for(count = 0; key_tag[count]; count++){
		if(!strcmp(para, key_tag[count])){
			flag = key_tag_flag[count]|F_CFRE;
				if(key.type[max_key] & F_CHECK)
					flag &= ~F_NUMBER;
			key.type[max_key] |= flag;
			return count;
		}
	}
	return -1;
}


static int
conc_opt(opt)
uchar *opt;
{
	int	len, size;
	uchar bf[REG_size];

	size = strlen(opt);

	if(f_conc & F_CONC){
		f_conc &= ~F_CONC;
		len = strlen(reg_buf);
		if(len + size >= REG_size - 1){
err:		fp_out = stderr;
			Fputs("Too long ");
			Fputs(reg_buf);
			Fputs(opt);
			putc('\n', stderr);
			exit(5);
		}
		strcpy(bf, reg_buf);
		strcpy(bf + len, opt);
		return get_opt(bf + (isdigit(bf[1])?0:1), O_COMMAND);
	}
	if(size > REG_size - 3){
		reg_buf[0] = 0;
		goto err;
	}
	strcpy(bf+2, opt);
	if(f_conc & F_CHEAD){
		bf[0] = 'H';
		bf[1] = ':';
		get_opt(bf, O_COMMAND);
	}else{
		set_reg(&key.re_buf[f_conc & F_CKEYGET], opt,
			key.trans[f_conc & F_CKEYGET]);
		f_conc &= ~(F_CKEY | F_CKEYGET);
	}
	return 0;
}

FILE *read_open(uchar *file, uchar *f_def)
{
	int	i, pos;
	uchar *fname;
	char *s;
	FILE *fp;

#define	R_MODE	"r"

	fname = (file != NULL && *file)?file:f_def;
	strcpy(reg_buf, fname);

	if(
#ifdef	UNIXPATH
		StrChr(reg_buf, PATH_SEP) != NULL && 
#endif
		(fp = fopen(reg_buf, R_MODE)) != NULL
	)
		return fp;

	s = (data_path0 == NULL)?"":data_path0;
	for(i=0;i<2;){
		if(!*s){
			s = data_path;
			i++;
			continue;
		}
		for(pos=0; pos < REG_size - 16; pos++){
			reg_buf[pos] = *s;
#ifdef  UNIXPATH
			if(*s == '~' && getenv("HOME")){
				strcpy(reg_buf, getenv("HOME"));
				pos = strlen(reg_buf)-1;
			}
#endif
			if(!*s || *s++ == PATH_SEP){
#ifndef	UNIXPATH
				if(reg_buf[0] == '~'){
					strcpy(reg_buf, org_path);
					pos = strlen(reg_buf) - 10;
					if(pos < 0)
						pos = 0;
				}
#endif
				reg_buf[pos++] = switch_ch;
				strncpy(reg_buf+pos, fname, (REG_size -1) - pos);
				if((fp = fopen(reg_buf, R_MODE)) == NULL)
					break;
				return fp;
			}
		}
	}
	return NULL;
}

static int
read_opt(file, mode)
uchar *file;
int mode;
{
	int	flag, pos, f_para, ch, i, f_all;
	FILE *fp;
	uchar bf[REG_size];
	uchar *opt;

	if(!*file)	return 0;
	pos = strlen(org_path);
	strcpy(org_path + pos - 4, ".cfg");
	strncpy(bf, file, REG_size - 4);
	bf[REG_size-3] = 0;
	if((opt = StrChr((isalpha(*bf) && bf[1] == ':')?(bf+2):bf, ':')) != NULL)
		*opt++ = f_all = 0;
	else
		f_all = 1;
	if((fp = read_open(bf, (def_cfg==NULL)?"psort.cfg":def_cfg)) == NULL){
non_exist:
		if(mode == O_FILE)
			return 0;
		fprintf(stderr, "Cannot find %s\n", file);
		exit(2);
	}
exist:
	pos = flag = f_para = 0;
	for(;;){
		ch = getc(fp);
		if(opt != NULL){
			if(ch == '\n')	continue;
			if(ch != '#')	goto skp_line;
			for(i = 0; opt[i]; i++){
				if(getc(fp) != opt[i])
					goto skp_line;
			}
			if(f_help && f_atty && !*opt){
				for(i = 0; (ch = getc(fp)) > ' ' && ch != '#'; i++)
					fputc(ch, stderr);
				if(i){
					fputc('	', stderr);
					if(i < 8)
						fputc('	', stderr);
				}
				goto skp_line;
			}
			if((ch = getc(fp)) <= ' '){
				if(f_help && f_atty){
					fprintf(stderr, "-:%s", opt);
					do{
						fputc(ch, stderr);
						if(ch == '\n'){
							if(getc(fp) != '#' || getc(fp) != '#')
								break;
						}
					}while((ch = getc(fp)) != EOF);
					exit(0);
				}
				opt = NULL;
			}
			goto skp_line;
		}
		if(ch == '\n' || ch == ' ' || ch == '\t' || ch == EOF){
			if(pos){
				bf[pos] = 0;
				if(bf[0] == '?' && (mode == O_FILE || mode == O_COMMAND)){
					f_conc |= F_CONC;
					strcpy(reg_buf, bf+1);
					goto end;
				}
				flag |= get_opt(bf + (isdigit(bf[1])?0:1), mode+1);
				f_sort |= flag;
				pos = f_para = 0;
			}
		}
		else if(f_para){
			bf[pos] = ch;
			if(++pos >= REG_size - 1){
				fprintf(stderr, "Too long option in %s\n", file);
				exit(5);
			}
		}
		else if(ch == '-' || ch == '+' || ch == '=' || ch == '?'){
			f_para = pos = 1;
			bf[0] = ch;
		}
		else if(!f_all && ch == '#'){
			if((ch = getc(fp)) == '#') goto skp_line;
			goto end;
		}
		else
skp_line:	for( ;ch != EOF && ch != '\n';ch = getc(fp));
nxt:	if(ch == EOF)
			break;
	}
end:
	fclose(fp);
	if(f_help && f_atty){
		fprintf(stderr, 
			"\n\nThe above can be used for <label>.\n"
			"psort -h -:<label>   for more information.\n");
		exit( 0 );
	}
	if(opt != NULL)	goto non_exist;
	return flag;
}

static int
next_key()
{
	if(++max_key >= MAX_KEY){
		fputs("Too many keys\n", stderr);
		exit(5);
	}
	return max_key;
}

static int
get_opt(para, mode)
uchar *para;
int mode;
{
	int	flag, num, type, equal;
	int *pt_int;
	uchar *tmp, *top;

	flag = num = 0;
	for(top = para; *para; ){
		if(isdigit(*para)){
			if(mode != O_RE){
err:			fprintf(stderr, "Invalid option in %s: %c",
					opt_err[mode], (mode==O_FIELD)?' ':'-');
				fp_out = stderr;
				Fputs(top);
				putc('\n', stderr);
				exit(5);
			}							/* define BLOCK in RE */
			goto opt_re;
		}

		switch(type = *para++){
			case 'b':					/* ignore blank */
				flag |= F_BLANK;
				continue;

			case 'i':					/* isprint() || isspace() */
				flag |= F_PRINT;
				continue;

			case 'f':					/* tolower() */
				flag |= F_SMALL;
				continue;

			case 'd':					/* isalnum() || isspace() */
				flag |= F_ALNUM;
				continue;

#ifdef	KANJI
			case 'j':					/* ignore 2 byte characters */
				flag |= F_KANJI;
				continue;
#endif
			case 'n':					/* float */
				flag |= F_FLOAT;
				continue;

			case 'N':					/* double */
				flag |= F_DOUBLE;
				continue;

			case 'z':					/* integer */
				flag |= F_INT;
				continue;

			case 'U':					/* unsigned */
				flag |= F_PNUM;
				continue;

			case 'r':					/* reverse */
				flag |= F_REVERSE;
				continue;

			case 'J':
				if(mode == O_RE || mode == O_FIELD){
					switch(*para){
						case '0':
para_j0:					uniq_o[max_key] |= UO_JTBL;
							break;

						case '1':
							uniq_o_len[max_key] = MJ_L1-1;
							break;

						case '2':
							uniq_o_len[max_key] = MJ_L2-1;
							break;

						case '3':
							uniq_o_len[max_key] = MJ_L3-1;
							break;

						case '4':
							uniq_o_len[max_key] = MJ_L4-1;
							break;

						default:
							para--;
							goto para_j0;
					}
					para++;
					continue;

				}else{
					if(j_table != NULL)	goto err;
					makeJtable((*para || def_tbl == NULL)?para:def_tbl);
					goto end;
				}

			default:
				break;
		}

		if(mode == O_RE){
			switch(type){
				case '+':						/* define skip block in RE */
					flag |= G_SKIP;
					goto opt_re;

				case '-':						/* define block in RE */
					flag |= G_TOEND;
opt_re:				key.pos[max_key] = atoi(para);
					skip_digit(&para);
					continue;

				case 'D':						/* define only RE */
					if(max_key || top_key) goto err;
					top_key = 1;
					continue;

				default:
					goto err;
			}
		}

		if(mode > O_FDEF)
			goto err;

		switch(type){
			case ':':					/* read option */
				para--;

			case 'g':					/* read file */
				if(mode >= O_FILE) goto err;
				return flag | read_opt(para, mode);

			case 'h':
				f_help = (*para=='0')?-1:1;
				return 0;

			case '/':
				switch_ch = *para;
				break;

			case 'u':					/* unique */
				while(*para){
					switch (*para++){
						case 'U':
							f_uniq |= (UNIQ_U|UNIQ_F);
							break;

						case 'D':
							f_uniq |= (UNIQ_D|UNIQ_F);
							break;

						case 'N':
							f_uniq |= (UNIQ_N|UNIQ_F);
							break;

						case '.':
							uniq_key = max_key;

						case 'u':
							f_uniq |= UNIQ_F;
							break;

						case '#':
							if( (max_key != 1 && max_key != top_key
							  && !f_direct)
								|| (!key.re_buf[0] && 
									(f_conc & (F_CKEY|F_CKEYGET)) != F_CKEY) )
								goto err;
							f_uniq |= UNIQ_O;
							tmp = StrPbrk(para, "!<>=");
							if(tmp == NULL) goto err;
							for( ; ; ){
								switch(*tmp){
									case '<':
										*tmp++ = 0;
										uniq_o[max_key] |= UO_S;
										break;

									case '>':
										*tmp++ = 0;
										uniq_o[max_key] |= UO_L;
										break;

									case '=':
										*tmp++ = 0;
										uniq_o[max_key] |= UO_E;
										break;

									default:
										goto qp;
								}
							}
qp:							if(!*para){
								key.pos[max_key]  = key.pos[0];
								key.type[max_key] = key.type[0]|F_CFRE;
							}
							else if( (key.pos[max_key] = get_key(para)) < 0 ){
								if( (key.pos[max_key] = *para - '0') < 0
							      || key.pos[max_key] >= RE_NREGS
								  || *(para+1) )
									goto err;
								key.type[max_key] = f_sort|F_CFRE;
							}
							key.bpos[max_key] = 0;
							if( !*tmp & (key.type[max_key] & F_NUMBER) )
								tmp = zero;

							switch( key.type[max_key] & F_NUMBER ){
								case F_STRING:
									modify_reg(tmp, 0);
									p_uniq[max_key].s = strdup(reg_buf);
									uniq_o_len[max_key] = strlen(reg_buf);
									break;

								case F_INT:
									p_uniq[max_key].i = atol(tmp);
									break;

								case F_FLOAT:
									p_uniq[max_key].f = atof(tmp);
									break;

								case F_DOUBLE:
									p_uniq[max_key].d = atof(tmp);
									break;
							}
							top_key = next_key();
							goto end;

						default:
							goto err;
					}
				}
				f_uniq |= UNIQ_F;
				break;

			case 't':					/* field separator */
				modify_reg(para, 0);
				field_sep = (uchar*)strdup(reg_buf);
				goto end;

			case 'q':					/* paragraph separator */
				modify_reg(para, 0);
				for(num=0, tmp=para; (tmp = StrChr(tmp, '\n')) != NULL;
					num++, tmp++ );
				para_sep_num = num;
				para_sep_len = strlen(reg_buf);
				para_sep = (uchar*)strdup(reg_buf);
				goto end;

			case 'H':
				if(head != NULL) goto err;

				if(*para == 'C'){
					f_head_only = 1;
					para++;
				}

				if(*para == ':'){
					if(*++para){
						if(!(f_conc & F_CHEAD))
							m_head = 0;
						else
							f_conc &= ~F_CHEAD;
						goto get_H;
					}
					m_head = 0;
					f_conc |= F_CHEAD;
					goto end;
				}

				for(m_head = 0; m_head < MAX_HEAD; m_head++){
					switch(*para){					/* get <key> */
						case 'F':
							mHead[m_head].type = H_FILE;
							f_direct = 1;
							break;

						case 'N':
							mHead[m_head].type = H_COUNT;
							break;

						case 'T':
							mHead[m_head].type = H_ORDER;
							break;

						case '.':
							mHead[m_head].pos = max_key - 1;
							if(*++para == '+') para++;
 							if(*para == '-' || isdigit(*para))
								mHead[m_head].pos += atoi(para);
							if(*para == '-')
									para++;
							skip_digit(&para);
							break;

						default:
							if(!isdigit(*para)) goto err;
							mHead[m_head].pos = atoi(para) - 1;
							skip_digit(&para);
							break;
					}
					for(;;){
						switch(*para++){			/* get options */
							case 'e':
								head_exist = m_head;
								break;

							case 'u':
								if(mHead[m_head].type & H_SPECIAL)
									goto err;
								f_uniq |= UNIQ_H;
								head_uniq = m_head;
								break;

							case 'S':
								mHead[m_head].type |= H_IGNORE;

							case 's':
								mHead[m_head].type |= H_SUM;
								f_sum = 1;
								break;

							case '/':
								goto next_key;

							case ':':
								m_head++;
								if(!*para){
									f_conc |= F_CHEAD;
									goto end;
								}
get_H:							modify_reg(para, 0);
								head = (char *)xmalloc(strlen(reg_buf)+1);
								strcpy(head, reg_buf);
								goto end;

							case 0:
								m_head++;
								goto end;
						}
					}
next_key:		}
				goto err;

			case 'o':					/* output file */
				foutname = strdup(para);
				goto end;

			case '$':					/* head of temporary file */
				strncpy(fname, para, MAX_PATH-1);
				if( (num = strlen(fname)) > MAX_PATH - 8)
					goto err;
				ptr_fname = fname + num;
				goto end;

			case 'S':					/* regular expression with options */
				tmp = para;
				for(;*para;){
					if(*para++ == ':'){
						*(para-1) = 0;
						break;
					}
				}
				key.type[max_key] = get_opt(tmp, O_RE);
				if(isdigit(*tmp) || *tmp == '+' || *tmp == '-')
					goto re2;			/* already set key.pos[max_key] */
				goto re1;

			case 's':					/* regular expression */
				key.type[max_key] = f_sort;
re1:			for(tmp=para; *tmp; tmp++){
					if( (
#ifdef	KANJI
					  iskanji(*tmp) || 
#endif
					  *tmp == '\\') && tmp[1]){
						tmp++;
						continue;
					}
					if(*tmp == '(')
						break;
				}
				key.pos[max_key] = (*tmp)? 1:0;
re2:			if(key.type[max_key] & F_MODIFY)
					make_table(&key.trans[max_key], key.type[max_key]);
				if(key.type[max_key] & F_CHECK){
					switch(key.type[max_key] & F_NUMBER){
						case F_INT:
							key.type[max_key] |= F_POS;
							break;

						case F_FLOAT:
							key.type[max_key] |= F_LENGTH;
							break;
					}
					key.type[max_key] = ((key.type[max_key]&~F_NUMBER)|F_INT);
				}
				if(*para || (f_conc & F_CKEY))
					set_reg(&key.re_buf[max_key], para, key.trans[max_key]);
				else
					f_conc |= (max_key | F_CKEY);
				next_key();
				goto end;

			case 'T':					/* former regular expression */
				if(*para == '#'){
					if(define_key(++para))	goto end;
					goto err;
				}
				for(tmp = para; *para; ){
					if(*para++ == ':'){
						*(para-1) = 0;
						break;
					}
				}
				*(pt_int = key.type + max_key) = get_opt(tmp, O_RE);
				switch(*para){
					case 'A':
						*pt_int = (*pt_int & ~KEY_STYPE)|S_ALL;
						break;

					case 'C':
						*pt_int = (*pt_int & ~KEY_STYPE)|S_COUNT;
						break;

					case 'F':
						*pt_int = (*pt_int & ~KEY_STYPE)|S_FILE;
						break;

					case 'L':
						*pt_int = (*pt_int & ~KEY_STYPE)|S_LINE;
						break;

					case 'N':
						*pt_int = (*pt_int & ~KEY_STYPE)|S_LINEN;
						break;

					case 'T':
						*pt_int = (*pt_int & ~KEY_STYPE)|S_LINET;
						break;

					case 'S':
						*pt_int = (*pt_int & ~KEY_STYPE)|S_SIZE;
						break;

					case '#':
						if( (key.pos[max_key] = get_key(++para)) < 0)
							goto err;
						num = 0;
						goto get_re;

					default:
						num = (*para)?(atoi(para)-1):0;
						*pt_int |= F_CFRE;
get_re:					if(num >= max_key || max_key < 0 ||
							 (!key.re_buf[num] &&
							  (f_conc & (F_CKEY|F_CKEYGET)) != (num|F_CKEY)) )
							goto err;
						key.bpos[max_key] = num;
						if(*pt_int & F_CHECK){
							if(*pt_int & F_NUMBER)
								*pt_int |= F_LENGTH;
							*pt_int = ((*pt_int & ~F_NUMBER)|F_INT);
						}
						if((*pt_int & F_NUMBER) == F_STRING)
							*pt_int |= (key.type[num] & F_MODIFY);
						break;
				}
				next_key();
				goto end;

			case 'P':					/* paragraph separator with options */
				if(isdigit(*para)){
					if((p_line = atoi(para)) < 1)
						goto err;
					goto end;
				}
				paragraph &= (P_CUT|P_CTOP);
				while(isalpha(*para)){
					switch (*para++){
						case 'v':
							paragraph |= P_DIV;
							break;
						case 't':
							paragraph |= P_TOP;
							break;
						case 'm':
							paragraph |= P_MUL;
							break;
						default:
							goto err;
					}
				}
				if((num = *para) == 0)
					goto skpp;
				para++;

			case 'p':					/* paragraph separator */
				if(!(paragraph & P_MUL))
					num = 0;
skpp:			paragraph |= P_FLG;
				if(*para || num){
					for( ; ; ){
						if(num){
							if((tmp = StrChr(para, num)) != NULL)
								*tmp = 0;
							else num = 0;
						}
						if(*para)
							set_reg(&re_para[max_re_para], para , NULL);
						if(++max_re_para >= MAX_PARA)
							goto err;
						if(!num) goto end;
						*tmp = num;
						para = tmp+1;
					}
				}
				goto end;

			case 'Q':							/* cut text */
				if(*para == 'e'){
					paragraph |= P_CTOP;
					para++;
				}
				paragraph |= P_CUT;
				if(!*para) goto end;
				if(*para++ != ':')
					goto err;
				set_reg(&re_pend, para , NULL);
				goto end;

			case 'C':
				if(*para == '+'){
					para++;
					f_re_cut = (G_TOEND|1);
				}else if(*para == '-'){
					para++;
					f_re_cut = (G_SKIP|1);
				}else
					f_re_cut = (G_JUST|1);
				if(isdigit(*para)){
					if((re_cut_pos = atoi(para)) < 0 || re_cut_pos >= RE_NREGS)
						goto err;
					skip_digit(&para);
				}
				for( ; ; ){
					switch(*para++){
						case 'r':
							f_re_cut |= G_CUT_REC;
							break;

						case 'W':
							f_re_cut |= G_CUT_REV;

						case 'w':
							f_re_cut |= G_CUT_WHOLE;
							break;

						case ':':
							set_reg(&re_cut, para , NULL);
							goto end;

						default:
							goto err;
					}
				}

			case 'D':
				f_direct = 1;
				break;

			case 'L':					/* maximal line length */
				if((room = atoi(para)) < MIN_LINE)
					goto err;
				goto end;

#ifdef	JIS
			case 'K':
				for(num = 8; num >= 0; num -= 4){
j_swt:				type = (f_jis & (0xf<<num));
					f_jis &= ~type;
					switch(*para++){
						case '7':
							f_jis |= J_Q7;
j_nxt:						if(num < 0)
								break;
							f_jis |= type;
							goto j_swt;

						case '$':
							if(!(esc_kanji_in[ESC_POS] = *para++))
								goto err;
							goto j_nxt;

						case '(':
							if(!(esc_kanji_out[ESC_POS] = *para++))
								goto err;
							goto j_nxt;

						case 'S':
							f_jis |= (J_CR<<num);

						case 's':
							f_jis |= (J_SJIS<<num);
							break;

						case 'j':
							kana8 = JO_KANA8;

						case 'J':
							f_jis |= (J_JIS<<num);

						case 'E':
							break;

						case ':':
							f_jis |= type;
							break;

						case 'q':
							f_jis |= J_QQ;

						case 'Q':
							f_jis |= (num == 4 && !(f_jis & (J_Q<<8)))?
								((f_jis & 0xf00)>>4):((J_Q|J_CR)<<num);
							break;

						case 0:
							f_jis |= type;
							goto end;

						default:
							goto err;
					}
				}
				if(*para == '$' || *para == '(' || *para == '7')
					goto j_swt;
				if(!*para)
					goto end;
				break;

#endif

#ifndef	MSDOS
			case 'M':					/* buffer size */
				if((buffer_size = atoi(para)*0x400) < MIN_BUF)
					goto err;
				max_line = buffer_size/sizeof(uchar *)/LINE_SIZE;
				goto end;
#endif

			case '=':
				equal = 1;
				goto fd;

			case '+':
				equal = 0;
fd:				if(!isdigit(*para)) goto err;
				key.pos[max_key] = num = atoi(para);	/* define a field */
				skip_digit(&para);
				if(*para == '.'){
					key.bpos[max_key] = atoi(++para);
					skip_digit(&para);
				}
				key.type[max_key] = 
					((*para)?get_opt(para, O_FIELD):f_sort)|F_FIELD;
				if(equal){
					key.type[max_key] |= F_FIELDE;
					key.end[max_key] = num+1;
					key.bend[max_key] = MAX_INT;
				}
				next_key();
				goto end;

			case '-':							/* define end of field */
				if(!max_key){
					key.pos[0] = 0;
					key.type[0] |= (f_sort | F_FIELD);
					max_key = 1;
				}
				if(!isdigit(*para)) goto err;
				key.end[max_key-1] = atoi(para);
				skip_digit(&para);
				if(*para == '.'){
					key.bend[max_key-1] = atoi(++para);
					skip_digit(&para);
				}else
					key.bend[max_key-1] = MAX_INT;
				key.type[max_key-1] |=
					(*para == 'b')?(F_FIELDE|F_BLANKB):F_FIELDE;
				goto end;

			default:
				goto err;
		}
	}
end:
	return flag;
}

static void
analyze_key()
{
	int	i, j, k, m;

	unit = (paragraph)?UNIT_PARA:0;

	for(i=0; i<max_key;i++){
		key.data[i] = unit;
		if(key.type[i] & F_MODIFY)
			make_table(&key.trans[i], key.type[i]);
		switch(key.type[i] & F_NUMBER){
			case F_STRING:
				unit += UNIT_STRING;
				break;

			case F_FLOAT:
#if  defined(BUS_FLT) || defined(BUS_DBL)
				key.data[i] =
					(unit += ((sizeof(float) -1 - unit) & (sizeof(float)-1)));
#endif
				unit += UNIT_FLOAT;
				break;

			case F_INT:
				unit += UNIT_INT;
				break;

			case F_DOUBLE:
#if  defined(BUS_FLT) || defined(BUS_DBL)
				key.data[i] = (unit += ((UNIT_GAP - unit) & UNIT_GAP));
#endif
				unit += UNIT_DOUBLE;
				break;
		}
		if (key.type[i] & F_FIELD){
			ref_key[max_field]   = i;
			ref_pos[max_field++] = key.pos[i];
			if((key.type[i] & (F_FIELDE|F_NUMBER)) == F_FIELDE){
				ref_key[max_field]   = (i | 0x80);
				ref_pos[max_field++] = key.end[i];
			}
		}
		if (key.type[i] & F_CFRE){
			j = key.bpos[i];
			while(key.end[j] > j)
				j = key.end[j];
			key.end[j] = i;
		}
	}

	for(i = 0; i < max_field - 1; i++){		/* sort fields by pos */
		m = ref_pos[i];
		k = i;
		for(j = i + 1; j < max_field; j++){
			if(ref_pos[j] < m)
				m = ref_pos[k=j];
		}
		if(i != k){
			ref_pos[k] = ref_pos[i];
			ref_pos[i] = m;
			m = ref_key[k];
			ref_key[k] = ref_key[i];
			ref_key[i] = m;
		}
	}
#ifdef	RE_PARA
	if(paragraph && re_para[0] == NULL)
		set_reg(&re_para[0], null_line, NULL);
#endif
}

static void
open_out()
{
#ifdef	JIS
		if((f_jis & JO_TYPE) == JO_Q && !f_direct){
				f_jis &= ~JO_Q;
				if(f_jis & J_JIS)
					JISmodeWrite();
				else if(!(f_jis & J_Q))
					f_jis |= ((f_jis & JO_SJIS)<< 4);
#ifdef	SJIS
				else
					f_jis |= JO_SJIS;
#endif
		}
#endif

	if (foutname){
 		if((fp_out = fopen(foutname, "w")) == NULL){
			fprintf(stderr, "Canot open %s\n", foutname);
			exit(2);
		}
	}
#ifdef	SJIS
	if((f_jis & (JO_SJIS|JO_CR)) == (JO_SJIS|JO_CR))
		f_jis &= ~JO_CR;
	else
		setmode(fileno(fp_out), O_BINARY);
#endif
	write_head = 0;
}

static	int	f_new_file = -1;
static int
opentext( argc, argv, opt )
int		argc, opt;
char	*argv[];
{
#ifdef	MSDOS
	static	struct ffblk ffblk;
	char	drive[MAXDRIVE], dir[MAXDIR], file[MAXFILE], ext[MAXEXT];
	char	filew[MAXFILE], extw[MAXEXT];
#endif
	static	FILE *fp_res;
	static	char s[MAX_PATH];
	int		ch, i;

#ifdef	JIS
	if(f_jis & J_QQ)
		KmodeRead();
#endif

	for( ; opt < argc; ){
		if(!f_new_file){					/* search next by wild cards */
#ifdef MSDOS
			f_new_file = findnext(&ffblk);
			goto get_f;
#else
			goto failed;
#endif
		}else if(fp_res != NULL){				/* read response file	*/
			for(i = 0; (ch = getc(fp_res)) != EOF; ){
				if(ch <= ' '){
					if(!i)	continue;
					else	break;
				}
				s[i] = ch;
				if(++i >= MAX_PATH - 1){
					fprintf(stderr, "Too long filename in %s\n", argv[opt]);
					exit(5);
				}
			}
			if(!i){
				fclose(fp_res);
				fp_res = NULL;
				opt++;
				continue;
			}
			s[i] = 0;
			filename = s;
		}else if(*argv[opt] == '@'){			/* open response file	*/
			fp_res = fopen(argv[opt] + 1, "r");
			if(fp_res == NULL)	opt++;
			continue;
		}else
			filename = argv[opt];					/* command parameter	*/
#ifdef	MSDOS
		f_new_file = findfirst(filename, &ffblk, FA_NORMAL);
		if(f_new_file)
			fprintf(stderr, "Cannot find file %s\n", filename);
get_f:	if(f_new_file)	goto failed;			/* doesn't exist		*/
		fnsplit(ffblk.ff_name, drive, dir, file, ext);
		fnsplit(filename, drive, dir, filew, extw);
		fnmerge(filename = s, drive, dir, file, ext);
#endif
		if( (fp_in = fopen(filename, "r")) != NULL ){
			f_new_file = 0;
			break;
		}else{									/* 	search again		*/
#ifndef	MSDOS
			fprintf(stderr, "Cannot find file %s\n", filename);
#endif
failed:		f_new_file = 1;
			if(fp_res == NULL)	opt++;
		}
	}
	if(!f_new_file){
		sprintf(reg_buf, "[%2d %s]\n", ++files, filename);
		mputs(reg_buf);
	}
	return opt;
}

void
usg()
{
	int	i, j, opt;
#ifndef	MSDOS
	char	tmp_in[8];
#endif

	if(!f_help){
		fprintf(stderr, "%s\tpsort -help [-[file]:[label]]\n", msg_usg);
		exit(0);
	}
usg:
	fprintf(stderr, msg, msg_usg);
	if( (fp_in = read_open(def_doc, "psort.doc")) != NULL ){
		if(pager != NULL){
			fclose(fp_in);
			if((i = strlen(pager)) > REG_size - 16)
				exit( 1 );
			memmove(reg_buf + i + 1, reg_buf, (REG_size - 1) - i);
			strcpy(reg_buf, pager);
			reg_buf[i] = ' ';
#ifdef	MSDOS
			opt = getch();
#else
			fgets(tmp_in, 2, stdin);
#endif
			system(reg_buf);
			exit( 0 );
		}
		opt = j = 0;
again:	for(i = MAX_SCREEN; fgets(reg_buf, 81, fp_in); i++){
				if(opt > 0){
					if(opt == 'R'){
						if(reg_buf[0] != '<' || reg_buf[1] != 'r')
							continue;
					}else if(opt == '-' || opt == '+' || opt =='='){
						if(reg_buf[0] != opt || reg_buf[1] != '<')
						continue;
				}else if(reg_buf[0] != '-' || reg_buf[1] != opt)
						continue;
					i = opt = 0;
					j = 2;
					putc('\n', stderr);
				}
				if((i >= MAX_SCREEN && strlen(reg_buf) < 2) 
 #if defined(MSDOS) || !defined(KANJI)
				   || (j == 2 && i > 1 && reg_buf[0] > ' ')
 #endif
				     ){
keyin:
#ifdef	MSDOS
					fputs(
						"(ESC, ! -> Quit, Char -> Opt, R -> re_exp, "
						"? -> Top, SP -> Cont, RET -> more)", stderr);
					opt = getch();
					fputs("\n\x1b[1A\t\t\t\t\t\t\t\t\t\t\n\x1b[1A", stderr);
					if(opt==0x1b || opt=='!'){
						j = -1;
						fclose(fp_in);
						exit(0);
					}

#else
					fputs(
 #if !defined(KANJI)
						"(! -> Quit, Char -> Opt, R -> re_exp, "
						"? -> Top, SP -> Cont, RET -> more)", 
 #else
						"\n(! -> Quit, Char -> Opt, R -> re_exp, "
						"? -> Top, RET -> more)", 
 #endif
						stderr);
					fgets(tmp_in, 7, stdin);
					if((opt = tmp_in[0])=='!'){
						j = -1;
						fclose(fp_in);
						exit(0);
					}
					putc('\n', stderr);
#endif
					if(opt == '?'){
						fclose(fp_in);
						goto usg;
					}
					i = 0;
					if(opt <= ' '){
#if defined(MSDOS) || !defined(KANJI)
						j = (opt == ' ')?2:-1;
#else
						j = -1;
#endif
						opt = 0;
					}else{
						j = 1;
						rewind(fp_in);
						continue;
					}
				}
				fputs(reg_buf, stderr);
		}
		rewind(fp_in);
		if(j==1) goto keyin;
		else goto again;
	}
	exit( 0 );
}

uchar *splitHead(uchar *s, struct mHead *mh)
{
	uchar *u, *v, *w;
 	int	flag;

/* printf("check->(%s)", s); */
	for(u = s; ; u += 2){
		if((u = StrChr(u, '%')) == NULL){
no_q:		v = (u = s + strlen(s)) - 1;
			break;
		}else if(*(u+1) == '%')						/* %% */
			continue;
		if((v = StrPbrk(u+1, "diouxXfegEGcs%np")) == NULL)
			goto no_q;
		if(*v == '%' || *v == 'c' || *v == '*' || *v == 'n')
			return NULL;							/* error */

		if(*v == 's'){								/* %...s */
			if(*(w = u+1) == '-'){
				mh->type = H_STRINGL;
				w++;
			}else
				mh->type |= H_STRING;
			mh->sum.len.mi = (isdigit(*w))? atoi(w):0;
			mh->sum.len.ma =
				((w = StrChr(w ,'.')) != NULL && w++ < v && isdigit(*w))?
					atoi(w):0;
		}else if(*v == 'p')							/*  %...p */
			mh->type |= H_FORMQ;
		break;
	}

	mh->head = w = xmalloc(v - s + 4);
	while(s < u){
		if( (*w++ = *s++) == '%' )					/* %% -> % */
			s++;
	}
	*w++ = 0;
	mh->form = w;
	if(!(mh->type & H_STRING)){
		while(s <= v)
			*w++ = *s++;
		*w = 0;
	}else
		strcpy(w, "%s");
	return(v+1);
}

static void
chkHead( )
{
	int	i, j, real;
	char *s;

	if(m_head > 0 || head != NULL){
		for(i = real = 0; i < m_head; i++){
			 if(!(mHead[i].type & H_IGNORE))
				real++;
		}
		if(head == NULL){
			if(real){
				head = (m_head>1)?MULT_HEAD:SINGLE_HEAD;
				if(f_head_only) head++;
			}else
				head = "";
		}
	}
	else return;
	if(head_uniq >= 0){									/* -H<key>u */
		if(head_uniq >= max_key)
			goto err_head;
		head_u_type = key.type[head_uniq] & F_NUMBER;
		head_uniq = key.data[head_uniq];
	}

	if(head_exist >= 0){								/* -H<key>e */
		if(head_exist >= max_key)
			goto err_head;
		head_e_type = key.type[head_exist] & F_NUMBER;
		head_exist = key.data[head_exist];
	}

	for(s = head, i = 0; *s != 0; i++){
		if(i > m_head || (s = splitHead(s, &mHead[i])) == NULL){
err_head:	fputs("Error in -H:", stderr);
			fp_out = stderr;
			Fputs(head);
			putc('\n', stderr);
			exit(5);
		}
	}


	if(real && (i == 0 || (*mHead[0].form == 0 && m_head > 0)))
		goto err_head;
												/* defined End of Head */
	mHead[m_head].head = (!i || *mHead[i-1].form)?(uchar *)"":mHead[--i].head;
	if(!i) i = 1;
	for(j = i--; j < m_head; j++){
		mHead[j].head = mHead[i].head;
		mHead[j].form = mHead[i].form;
		mHead[j].sum.len.mi = mHead[i].sum.len.mi;
		mHead[j].sum.len.ma = mHead[i].sum.len.ma;
		mHead[j].type |= (mHead[i].type & H_FORM);
	}
	for(i = 0; i < m_head; i++){
		j = mHead[i].pos;
		if(!(mHead[i].type & H_SPECIAL)){
			if(j < 0 || j >= max_key)
				goto err_head;
			mHead[i].pos = key.data[j];
			mHead[i].type |= key.type[j] & F_NUMBER;
		}
		if(mHead[i].type & F_NUMBER){
			if((mHead[i].type & H_FORM) == H_FORMQ)
				goto err_head;
			switch(mHead[i].type & F_NUMBER){
				case F_FLOAT:
					mHead[i].sum.f = 0;
					break;

				case F_DOUBLE:
					mHead[i].sum.d = 0;
					break;
			}
		}else
			if((mHead[i].type & H_FORM) == H_NUMBER)
				goto err_head;
	}
}

void
print_sum()
{
	int	i;

	if(f_sum){
		fprintf(fp_out, "\n[Sum ");
		for(i = 0; i < m_head; i++){
			if(!(mHead[i].type & H_SUM)) continue;
			switch(mHead[i].type & F_NUMBER){
				case F_INT:
					fprintf(fp_out, ": " INT_OUT, mHead[i].sum.i);
					break;

				case F_FLOAT:
					fprintf(fp_out, ": %g", mHead[i].sum.f);
					break;

				case F_DOUBLE:
					fprintf(fp_out, ": %lg", mHead[i].sum.d);
					break;
			}
		}
		fprintf(fp_out, " (#Head: " INT_OUT ")]\n", head_count);
	}
}

void get_default()
{
	FILE	*fp;
	char	*s;
	int		i, j, k;

	char	*def_str[5] = 
	{"PATH", "PAGER", "DOC", "TBL", "CFG"};

#ifdef	UNIXPATH
	reg_buf[0] = 0;
	if(getenv("HOME"))
		strcpy(reg_buf,getenv("HOME"));
	strcat(reg_buf, CFG_FILE);
	if((fp = fopen(reg_buf, "r")) != NULL ||
	   (fp = fopen(CFG_FILE2, "r")) != NULL)
#else
	strcpy(reg_buf, org_path);
	strcpy(reg_buf + strlen(reg_buf) - 9, CFG_FILE);
	if((fp = fopen(reg_buf, "r")) != NULL)
#endif
	{
		while(fgets(reg_buf, REG_size-1, fp)){
			for(i=0;i<5;i++){
				for(j=0; ;j++){
					if(def_str[i][j]){
						if(def_str[i][j] == reg_buf[j])
							continue;
						break;
					}
					while(reg_buf[j] != '='){
						if(!reg_buf[j++])
							goto next;
					}
					while(reg_buf[++j] <= ' ')
						if(!reg_buf[j]) goto next;
					k = j;
					while(reg_buf[++k] > ' ');
					reg_buf[k] = 0;
					psortrc[i] = strdup(reg_buf+j);
				}
			}
next:
		}
		fclose(fp);
	}
	if(pager == NULL && getenv("PAGER") != NULL)
		pager = strdup(getenv("PAGER"));
}

void
main( argc,argv )
int		argc;
char	*argv[];
{
	int		i, j, linecnt, opt;
	FILE	*fp_tmp;

start:
	strncpy(org_path, argv[0], MAX_ARG0 - 8);
	i = strlen(org_path);
	if(i > 4 && org_path[i-4]== '.')
		i -= 4;
	strcpy(org_path + i, ".doc");				/* path of psort.doc	*/

	if(argc)
		get_default();							/* read .psortrc		*/

	if( isatty(fileno( stdin )) ){
		if( argc < 2 )	usg();					/* 			HELP		*/
		f_eof = 1;
	}else
		fp_in = stdin;

	f_atty = isatty(fileno( stdout ));			/* redirect output?		*/

	re_set_syntax(MSORT_RE);
												/***   read options	   ***/
	for (opt = 1; opt < argc && strcmp(argv[opt], "-g"); opt++);
	if(opt == argc)
		f_sort = read_opt(def_tag, O_FILE);		/* from default file 	*/

	for ( opt = 1; opt < argc; opt++ ){			/* from command parameter */
		if(f_conc){
			f_sort |= conc_opt(argv[opt]);
			continue;
		}
		if(*argv[opt] != '+' && *argv[opt] != '-' && *argv[opt] != '=')
			break;
		f_sort |= get_opt(argv[opt] + (isdigit(argv[opt][1])?0:1), O_COMMAND);
	}
	if (f_conc){
		fputs("Not enough parameters\n", stderr);
		exit(5);
	}

	if (f_help ||						/* help */
		(opt >= argc && f_eof)){		/* no texts and redirect input	*/
		argc = 0;
		goto start;
	}

	if(foutname == NULL)					/* no -o option		*/
		f_atty += 2 ;

#ifdef	SJIS
	if(!f_atty & (f_jis & (JO_SJIS|JO_CR)) != (JO_SJIS|JO_CR))
		setmode(fileno(fp_out), O_BINARY);
#endif

	if(max_re_para > 1)						/* -Pm option		*/
		p_line += max_re_para - 1;

	if(!max_key){							/* no key defined	*/
		key.type[0] |= F_FIELD|f_sort;
		max_key++;
	}

	max_key2 = max_key;						/* for -u. option	*/
	if(!uniq_key)
		uniq_key = max_key;

	if(ptr_fname == NULL){					/* no -$ option		*/ 
#ifdef MSDOS
		i = 0;
		if( ((ptr_fname = getenv("TEMP")) != NULL
		  || (ptr_fname = getenv("TMP"))  != NULL )
		  && (i = strlen(ptr_fname)) < MAX_PATH - 10 ){
			strcpy(fname, ptr_fname);
			if(i && (fname[i-1] != switch_ch))
				fname[i++] = switch_ch;
		}
		ptr_fname = fname + i + 1;
		strcpy(ptr_fname - 1, "$");
#else
		strcpy(fname, "temp");
		ptr_fname = fname + strlen(fname);
#endif
	}

	analyze_key();							/* analyse keys		*/

	chkHead();								/* -H<pos> option	*/

#ifdef	MSDOS								/* get mempory		*/
	buffer_size = farcoreleft() - SUB_size;
#endif
	if ( buffer_size <= 0
	  || (lptr = (uchar **)Calloc(buffer_size + 2, 1) ) == NULL ) {
nomem:	fputs( "Not enough work space.  Execution terminated.\n",
				stderr );
		exit(1);
	}
	(HUGEBUF*)work = (HUGEBUF*)lptr + (long)max_line*sizeof(uchar *);
	(HUGEBUF*)tex0 = (HUGEBUF*)work + ((long)max_line/2+2)*sizeof(uchar *);
	buffer_size -= ((long)max_line*3/2+2)*sizeof(uchar *);
	if(buffer_size < MIN_size) goto nomem;
	div_size = buffer_size/MAXDIV & ~UNIT_GAP;
	read_head = write_head = unit;

	if((paragraph || p_line > 1) && field_sep == NULL)	/* paragraph mode	*/
		field_sep = pblank;

	if(top_key >= max_key)					/* no need of sort	*/
		f_direct = 1;

	if(fp_in == stdin){
		mputs("[ 1 stdin]\n");
		files++;
	}
#ifdef	JIS
	KmodeRead();
#endif

	for(;;){								/* sort on memory	*/
		linecnt = 0;
		text=tex0;
		left = buffer_size - unit - UNIT_GAP;
		if(f_eof){
rep:		if( opt >= argc ) break;
			if( (opt = opentext(argc, argv, opt)) >= argc ){
				if(files) goto end0;
				fcloses(div0, div0-1);
				fputs("Read no text\n", stderr);
				exit(2);
			}
			f_eof = 0;
		}
		linecnt = readdata(linecnt);
end0:	if(f_direct){
			if(f_direct & 1){
				f_direct++;
				open_out();
			}
			for(i=0; i<linecnt; i++)
				writeoneline(lptr[i]);
			continue;
		}
		if( opt < argc && f_eof ){
		        text += (~(text - tex0 - 1) & UNIT_GAP);
			goto rep;
		}
		strmsort( lptr, linecnt - 1 );
		if( !div1 && f_eof ){
			open_out();
			writedata( linecnt );
end1:		if( f_uniq & UNIQ_F )
				end_uniq();
			if( f_err < 0 ){
				fputs( "Error occurred in writing a file!", stderr );
				exit( 1 );
			}
			print_sum();
			fclose(fp_out);
			exit( 0 );
		}
		makename( div1 );
		if( !div1++ )
			mputs("[Open tempolary files]\n");
		fp_tmp = fp_out;
		fp_out = fopen( fname, "w" );
		writedata( linecnt );
		fclose( fp_out );
		fp_out = fp_tmp;
	}
	if(f_direct)
		goto end1;
									/* sort using tempolary files  */
	f_uniq &= ~UNIQ_O;
	tex[0] = tex0;
	for( i = 1; i < MAXDIV; i++ ){
		(HUGEBUF*)tex[i] = (HUGEBUF*)tex[i-1] + div_size;
	}
	if( max_parasize >= div_size ){
		fputs( "Too long paragraph!", stderr );
		exit( 2 );
	}

rep2:
	if( (i = div1 - div0) <= 4 ){				/* final sort */
		open_out();
		if(f_uniq)
			f_uniq |= UNIQ_C;
		fopens( div0, i );
		sort( i );
		fcloses( div0, i );
		goto end1;
	}
	div2 = div1;
	for( i = div0; i < div1; i += 4 ){		/* intermediate sort	*/
		j = div1 - i;
		if( j < 2 ){
			div1--;
			goto next;
		}
		else if( j > 4 ) j = 4;
		makename( div2++ );
		fp_tmp = fp_out;
		fp_out = fopen( fname, "w" );
		fopens( i, j );
		sort( j );
		fclose( fp_out );
		fp_out = fp_tmp;
		fcloses( i, j );
	}
next:
	div0 = div1;
	div1 = div2;
	goto rep2;
}

static void
fopens( div, i )
int		div, i;
{
	int		j;

	for( j = 0; j < i; j++ ){
		makename( div+j );
		if( (fp[j] = fopen( fname, "r" )) == NULL ){
			fputs( "Cannot open temporal file!\n", stderr );
		}
	}
}

static void
fcloses( div, i)
int		div,i;
{
	int		j;

	for( j = 0; j < i; j++ ){
		fclose( fp[j] );
		makename( div+j );
		remove( fname );
	}
}

static void
sort( num )
int	num;
{
	int		i, j, k, l, result;

	for( i = 0; i < num; i++ )	k = lgets( ord[i] = i );
	if( !k ) num--;

	for( i = 1; i < num; i++ ){
		for( j = i; j > 0; j-- ){
			if( compare(tex[ord[j-1]], tex[ord[j]]) > 0 ){
				k = ord[j];
				ord[j] = ord[j-1];
				ord[j-1] = k;
			}
		}
	}

rep:
	i = ord[num-1];

	if( num > 2 ){
	    for( ; ; ){
		    if( (result = compare( tex[ord[1]], tex[i] )) > 0
			  || (!result && i < ord[1]) ){
				if( (result = compare( tex[ord[0]], tex[i] )) > 0
				  || (!result && i < ord[0]) ){
			   		 j = -1;
				}
				else j = 0;
		    }
			else if( num == 4 ){
				if( (result = compare( tex[ord[2]], tex[i] )) > 0
				  || (!result && i < ord[2]) ){
			   		 j = 1;
				}
				else j = 2;
			}
		   	else     j = 1;
			if( j < 0 )
				writeoneline(tex[i]);
			else{
				writeoneline(tex[ord[0]]);
		    	l = i;
		    	i = ord[0];
		    	for( k = 0; k < j; k++ ) ord[k] = ord[k+1];
		    	ord[j] = l;
	    	}

			if( !lgets(i) ){
				num--;
				goto rep;
		    }
		}
	}

	else if( num == 2 ){
		k = ord[0];
    	for( ; ; ){
	    	if( (result = compare( tex[k], tex[i] )) > 0 )
rec1:			writeoneline(tex[i]);
			else if( result ){
rec2:			writeoneline(tex[k]);
				j = k;
				k = i;
				i = j;
			}
			else{
				if( i < k )		goto rec1;
				else			goto rec2;
			}
			if( !lgets(i) ){
				num--;
				ord[0] = k;
				goto rep;
			}
		}
	}
	else {
		do{
			writeoneline(tex[i]);
		}while( lgets( i ) );
	}
}

static void
getnum( top, fpt )
uchar *top;
FILE *fpt;
{
	int	i;

	for(i=unit; i-- > 0; ){
		*top  =   getc(fpt) - '0';
		*top += ((getc(fpt) - '0')<<4);
		 top++;
	}
}

static lgets( num )
int		num;
{
	BUFFER	*temp;
	int		count;
	FILE	*fpt;

	getnum(temp = tex[num], fpt = fp[num]);
	count = (paragraph)?to_int(temp):p_line;
	temp += unit;
	for(;;){
		if(!fgets( temp, room, fpt )) return 0;
		if(--count <= 0) break;
		temp += strlen(temp);
	}
	return 1;
}


static void
strmsort(ptr,last)
uchar	*ptr[];
int last;
{
	int	middle, i, j, k, p;
	int	first = 0;

	if((middle = last/2) < THRESHOLD){
		strisort(ptr, middle);
		strisort(ptr+middle+1, last-middle-1);
	}else{
		strmsort(ptr, middle);
		strmsort(ptr+middle+1, last-middle-1);
	}
	for(p=0, i=first; i<= middle; i++)
		work[p++] = ptr[i];
	i = middle + 1;
	j = 0;
	k = first;
	while(i <= last && j < p){
		if(compare(work[j], ptr[i]) <= 0)
			ptr[k++] = work[j++];
		else
			ptr[k++] = ptr[i++];
	}
	while(j < p) ptr[k++] = work[j++];
}


static void
strisort(ptr, upper)
uchar	*ptr[];
int upper;
{
	int	i, j;
	uchar *t;

	for (i = 1; i <= upper; i++ ){
		t = ptr[i];
		for( j = i-1; j >= 0 && compare(ptr[j], t) > 0; j-- )
			ptr[j+1] = ptr[j];
		ptr[j+1] = t;
	}
}

void *
xmalloc(size)
int	size;
{
	void *p;

	if (size <= 0 || (p = malloc(size)) == NULL) {
		fprintf(stderr, "Memory exhausted.");
		exit(2);
	}
	return p;
}
